/****************************************************************************
 *
 * /home/bat/bat/fast3202_4_0_21_3_3_1/rg/vendor/adi/ad6843/common/kernel/luminus.c
 * 
 * Copyright (C) Jungo LTD 2004
 * 
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Developed by Jungo LTD.
 * Residential Gateway Software Division
 * www.jungo.com
 * info@jungo.com
 */

#include <asm/io.h>
#include <asm/time.h>
#include <linux/interrupt.h>
#include <linux/module.h>

#include <adi6843.h>
#include <timer.h>
#include <irq.h>
#include <vendor/luminus.h>
#include <linux/sbi_k.h>

#define LUM_TIMER_ENABLE (1 << 12)
#define LUM_TIMER_DISABLE (1 << 13)
#define LUM_TIMER_RESET 0x4

#define AUTO_DEFAULT_CLOCK      100000000

static volatile struct timer_regs   __attribute__ ((packed)) *tregs =
                        (volatile struct timer_regs   __attribute__ ((packed)) *)KSEG1ADDR(0x19070000);

int ad6843_luminus_interrupt(int irq, void *dev_id, struct pt_regs *regs)
{
    u16 status;

    status = tregs->status2;
    
    tregs->status2 = status & LUM_TIMER_RESET;
/* Bug 2852  Mod LUA */
    return IRQ_HANDLED;
}

int ad6843_luminus_enable(int enable)
{
    tregs->status2 = enable ? LUM_TIMER_ENABLE|LUM_TIMER_RESET :
	LUM_TIMER_DISABLE|LUM_TIMER_RESET;

    return 0;
}

int ad6843_luminus_setup(struct irqaction *irq)
{
    unsigned long clock = AUTO_DEFAULT_CLOCK;
    unsigned long period;
    unsigned long width;

    setup_irq(GPT3_INT, irq);
    period = clock / 1000; /* Clock is set to 100MHz, we need 1KHz */
    width = period / 2;

    tregs->config2 = 0x1d;
    tregs->period_hi2 = period >> 16;
    tregs->period_lo2 = period & 0xFFFF;
    tregs->width_hi2 = width >> 16;
    tregs->width_lo2 = width & 0xFFFF;
    ad6843_luminus_enable(1);

    return 0;
}

EXPORT_SYMBOL(ad6843_luminus_setup);
EXPORT_SYMBOL(ad6843_luminus_interrupt);
EXPORT_SYMBOL(ad6843_luminus_enable);
