/**
 * @note Copyright (c) 2006  Sagem Communication All rights reserved
 *
 * @file sbi_200.c
 * @version 1.0
 * @date 25/11/2006
 * @author Sagem Communication
 * @brief 
**/
#include <linux/sbi_k.h>
#include <linux/sbi_k_200.h>

struct interrupt_numbers vox200_int_nums = 
{
	.adi_6843_max_ints	= 32,
	.ap_dma_int		= -1,
	.arb2_int		= 12,
	.arb3_int		= 27,
	.arb_int		=  1,
	.bmu_int		= 31,
	.dma_int		=  0,
	.dsp0_fl0_int		= 17,
	.dsp0_fl1_int		= 18,
	.dsp0_pf0_int		= 19,
	.dsp0_pf1_int		= 20,
	.dsp1_fl0_int		= 21,
	.dsp1_fl1_int		= 22,
	.dsp1_pf0_int		= 23,
	.dsp1_pf1_int		= 24,
	.emac1_int		= 14,
	.emac2_int		= 13,
	.emac3_int		= 26,
	.gpio2_int		= -1,
	.gpio_int		=  8,
	.gpt1_int		=  9,
	.gpt2_int		= 10,
	.gpt3_int		= 11,
	.idma1_int		= 16,
	.idma2_int		= 15,
	.idma3_int		= -1,
	.pci_int		= 25,
	.per_int		= -1,
	.scu_int		=  2,
	.spa_int		= 30,
	.sphy_int		= -1,
	.spi_int		=  7,
	.sport2_rx_int		= -1,
	.sport2_tx_int		= -1,
	.uart1_int		=  6,
	.uart2			= -1,
	.uart2_int		= 29,
	.usbh_int		= -1,
	.usb_int		=  3,
	.wiu1_int		=  5,
	.wiu2_int		=  4
	
};


unsigned long vox200_mtd_partition_jffs2_offset = 0x00380000;
unsigned long vox200_mtd_partition_jffs2_size   = 0x00070000;
int vox200_first_pci_pin = 21;
int vox200_adsl_gpio_reset_bit = 14;
int num_emac_ports_200 = 1;

int init_sbi_200(void) 
{

	sbi->int_nums = &vox200_int_nums;
	sbi->mtd_partition_jffs2_offset = vox200_mtd_partition_jffs2_offset; 
	sbi->mtd_partition_jffs2_size = vox200_mtd_partition_jffs2_size; 
	sbi->adsl_gpio_reset_bit = vox200_adsl_gpio_reset_bit;
	sbi->first_pci_pin = vox200_first_pci_pin;
	//sbi->sbi_bmap_tasklet = bmap_tasklet_200;
	sbi->mem_detect = vox200_mem_detect;
	sbi->fusiv_init_IRQ = fusiv_init_IRQ_200;
	sbi->num_emac_ports = num_emac_ports_200;
	sprintf(sbi->board_name, "VOX200 - 0x%04x", CPU_ID);
	return 0;
} 


// Modif FR Integration of V31 on Mini 20070316
//DECLARE_TASKLET(bmap_tasklet_200, bmHostTask_200, 0);

static int vox200_mem_detect_bank(int bank)
{
	volatile unsigned int mem_reg = 0, mem_size = 0;
	int nbanks = 0, device_size = 0;		
	
	mem_reg = (*(volatile unsigned int*)0xb9140004);
	nbanks = (mem_reg&(0x1<<(8*bank))) ? 1 : 0;
	switch ((mem_reg>>(1+(8*bank)))&0x3) {
		case 0x0:	device_size =  16; break;
		case 0x1:	device_size =  32; break;
		case 0x2:	device_size =  64; break;
		case 0x3:	device_size = 128; break;
		default: 	BUG();             break;
	}
	mem_size = (nbanks*device_size) >>3;
	return mem_size;
}

int vox200_mem_detect(void)
{
	int i;
	unsigned int mem_size = 0;
	for (i=0; i<4 ; i++)
		mem_size += vox200_mem_detect_bank(i);
	sbi->sdram_size = mem_size;
	
	return 0;
}

