/* =============================================================================
 *
 * Copyright (C) 2005  Analog Devices Inc. All rights reserved
 * The information and source code contained herein is the property
 * of Ikanos Communications.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 * ===========================================================================*/
#ifndef _ADI6843_H_
#define _ADI6843_H_

/* Interrupt controller registers */

typedef struct {
	unsigned long l;
	unsigned long h;
} int_stat_t;


#define ADI_6843_UART0_ADDR	KSEG1ADDR(0x19020000)


/**
 *
 * VOX 150 Board specific declarations and defines.
 *
 */


typedef struct {
        unsigned long   ipc_id;         /* Interrupt controller ID */
        unsigned long   pad1[0x3f];     /* Reserved */
       unsigned long   cpe_prio[8];    /* CPE Interrupt Priority Registers */
       unsigned long   ap_prio;        /* AP Interrupt Priority Register */
       unsigned long   pad2;           /* Reserved */
       int_stat_t      cpe_stat[11];   /* CPE Interrupt Status Registers*/
       int_stat_t      emac_stat[3];   /* EMAC AP Interrupt Status Registers */
       int_stat_t      bmu_stat;       /* BMU AP Interrupt Status Registers */
       int_stat_t      spa_stat;       /* SPA AP Interrupt Register */
       int_stat_t      pci_stat;       /* PCI Interrupt Registers */
       unsigned long   pad3[0x54];     /* Reserved */
       unsigned long   cpe_per;        /* CPE Peripheral Interrupt */
} ipc_t200;
typedef struct {
        unsigned long   ipc_id;         /* Interrupt controller ID */
        unsigned long   pad1[0x3f];     /* Reserved */
        unsigned long   cpe_prio[10];   /* CPE Interrupt Priority Registers */
        int_stat_t      cpe_stat[10];   /* CPE Interrupt Status Registers*/
        int_stat_t      emac_stat[3];   /* EMAC AP Interrupt Status Registers */
        int_stat_t      bmu_stat;       /* BMU AP Interrupt Status Registers */
        int_stat_t      peri_stat;      /* Peripheral AP Interrupt Register */
        int_stat_t      pci_stat;       /* PCI Interrupt Registers */
        unsigned long   pad3[0x54];     /* Reserved */
        unsigned long   cpe_per;        /* CPE Peripheral Interrupt */
} ipc_t160;

#endif /*_PROFILE_ADI6843_H_*/

