/*************************************************/
/*                                               */
/* Character device access to Livebox 2 GPIO     */
/* using IOCTLs                                  */
/*                                               */
/*************************************************/
#ifndef GPIO_LED_BTN_CHARDEV_H
#define GPIO_LED_BTN_CHARDEV_H 1

#define GPIO_LED_BTN_MAJOR 249
#define GPIO_LED_BTN_MINOR   0
#define GPIO_LED_BTN_NAME  "gpio_lb2"

#define GPIO_LED_BTN_IOCTL_CMD_NUMBER 0
#define GPIO_GET_REQUEST 0
#define GPIO_SET_REQUEST 1
#define GPIO_GET_HARDWARE 2

struct lb2_gpio_ioctl_request_t {
	int request_type; /*  GPIO_GET_REQUEST or  GPIO_SET_REQUEST         */
	int bit_number;   /* The bit number to affect ( value from 0 to 31) */
	int bit_value;    /* The value to set, or the state of the bit for a get request */
	int result;       /* 0 if the operation is successful, or -1        */
};

#endif
