/****************************************************************************
 *
 * /home/bat/bat/fast3202_4_0_21_3_3_1/rg/vendor/adi/ad6843/common/kernel/luminus.h
 * 
 * Copyright (C) Jungo LTD 2004
 * 
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Developed by Jungo LTD.
 * Residential Gateway Software Division
 * www.jungo.com
 * info@jungo.com
 */

#ifndef _LUMINUS_H_
#define _LUMINUS_H_

int ad6843_luminus_enable(int enable);
int ad6843_luminus_interrupt(int irq, void *dev_id, struct pt_regs *regs);
int ad6843_luminus_setup(struct irqaction *irq);

//No luminus if the livebox hardware has been rebranded  (bug 2141) - Sagem 20061002
/* Relative address for permanent parameters */
#define PERM_PARAMS_BASE	(0xbf800000 + 0x3c00)
#define MAX_PERMPARAMS_VENDORINFO4_SIZE 	32

/* Permanent parameters structure */
typedef struct permanent_param_s {
	unsigned char	type[12];
	unsigned char	productID[32];
	unsigned char	productRevision[8];
	unsigned char 	productHWVersion[8];
	unsigned char	serialNumber[12];
	unsigned char	manufacturedDate[8];
	unsigned char	DSLChipsetVendor;
	unsigned char	splitterType;
	unsigned char	dyingGasp;
	unsigned char	modemType;			/* dsl modem type 0x00, 0x01, 0x02, 0x03 */
	unsigned char	ADIPID;				/* 1 - eagle I, 2 - eagle II, 3 - PF, 4 - eagle III */
	unsigned char	ledSupport;
	unsigned char	sdramSize;
	unsigned char	sdramTestMode;
	unsigned char	DSLProviderCode[4];
	unsigned char	splitterID[32];
	unsigned char	ADIChipsetType[2];
	unsigned char	pad2[2];
	unsigned char	REALM_HTTP[128];
	unsigned char	EMAC0_MacAddr[6];
	unsigned char	USB_MacAddr[6];
	unsigned char	EMAC1_MacAddr[6];
	unsigned char	EMAC2_MacAddr[6];
	unsigned char	WLAN_MacAddr[6];
	unsigned char	AdminUserName[16];
	unsigned char	AdminPassword[16];
	unsigned char	PPPoEUserName[16];
	unsigned char	PPPoEPassword[16];
	unsigned int	ETH0_IPAddr;
	unsigned int	ETH0_SubnetMask;
	unsigned int	ETH1_IPAddr;
	unsigned int	ETH1_SubnetMask;
	unsigned int	ETH2_IPAddr;
	unsigned int	ETH2_SubnetMask;
	unsigned int	ATM_IPAddr;
	unsigned int	ATM_SubnetMask;
	unsigned int	USB_IPAddr;
	unsigned int	USB_SubnetMask;
	unsigned int	WLAN_IPAddr;
	unsigned int	WLAN_SubnetMask;
	unsigned int	DHCP_StartIPAddr;
	unsigned int	DHCP_EndIPAddr;
	unsigned int	DNS_IPAddr;				/* export to dhcp client */
	unsigned int	GatewayIPAddr;			/* export to dhcp client */
	unsigned int	LoopBackIPAddr;			/* local loop back address */
	unsigned char	BridgeVCI;
	unsigned char	BridgeVPI;
	unsigned char	BridgeEncapsulation;	/* encapsulation for bridge vpi/vci */
	unsigned char	PPPoEVCI;
	unsigned char	PPPoEVPI;
	unsigned char	PPPoEEncapsulation;		/* encapsulation for pppoe vpi/vci */
	unsigned char	PPPoAVCI;
	unsigned char	PPPoAVPI;
	unsigned char	PPPoAEncapsulation;		/* encapsulation for pppoa vpi/vci */
	unsigned char	RoutedVCI;
	unsigned char	RoutedVPI;
	unsigned char	RoutedEncapsulation;	/* encapsulation for routed vpi/vci */
	unsigned char	DHCPServerMode;			/* enable/disable */
	unsigned char	vendorInfo1[32];
	unsigned char	vendorInfo2[32];
	unsigned char	vendorInfo3[32];
	unsigned char	vendorInfo4[32];
}PermanentParameter_t;
//End bug 2141

#endif
