/**
 * @note Copyright (c) 2006  Sagem Communication All rights reserved
 *
 * @file sbi_utils.c
 * @version 1.0
 * @date 25/11/2006
 * @author Sagem Communication
 * @brief 
**/
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/sbi_k.h>
#include <linux/sbi_k_160.h>
#include <linux/sbi_k_200.h>


struct sagem_board_info sagem_board_info = { .flash_size = 64/*16*/ };
struct sagem_board_info * sbi; 

int init_sbi_cpu(void)
{
	sbi = &sagem_board_info;
	sbi->cpu_id = ADI_CPU_TYPE;
	switch(sbi->cpu_id) {
		case 0x6836://VOX160
			init_sbi_160();
            break;
		case 0x6833 ... 0x6834://V0X150-200
			init_sbi_200();
            break;
		default:
			BUG();
            break;
	}
	return 0; 
}

EXPORT_SYMBOL(sbi);



