/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#include <oswrapper.h>

dsp_regExtModForClock_str *dsp_regExtMod = NULL;
//FCLUZEAU
dsp_regExtModForRelay_str *relay = NULL;

//FCLUZEAU
/***********************************************************************
 * Function    : dsp_regExtModForRelay.                                *
 * Description : Function to register Ext Module Relay call backs.     *
 * Input       : dsp_regExtModForRelay_str                             *
 * Output      : None                                                  *
 * Return      : None.                                                 *
 **********************************************************************/
void dsp_regExtModForRelay(dsp_regExtModForRelay_str *callbacks)
{
  relay = callbacks;
}
EXPORT_SYMBOL(dsp_regExtModForRelay);
void dsp_unregExtModForRelay(void)
{
  relay = NULL;
}
EXPORT_SYMBOL(dsp_unregExtModForRelay);
/***********************************************************************
 * Function    : extModRegisterCallBacks.                              *
 * Description : Function to register Ext Module call backs.           *
 * Input       : dsp_regExtMod_str                                     *
 * Output      : None                                                  *
 * Return      : None.                                                 *
 **********************************************************************/
void dsp_regExtModForClock(dsp_regExtModForClock_str *callbacks)
{
  dsp_regExtMod = callbacks;
}
EXPORT_SYMBOL(dsp_regExtModForClock);

/***********************************************************************
 * Function    : extModUnRegisterCallBacks.                            *
 * Description : Function to unregister Ext Module call backs.         *
 * Input       : None                                                  *
 * Output      : None                                                  *
 * Return      : None.                                                 *
 **********************************************************************/
void dsp_unregExtModForClock(void)
{
  dsp_regExtMod = NULL;
}
EXPORT_SYMBOL(dsp_unregExtModForClock);
