#include <oswrapper.h>


#define JIT_RTCP_ONE_WAY      80

#ifdef JIT_FLOATING_POINT
  #define ALPHA             0.3 //0.43 // 0.7 // 0.875  // 0.9
#else
  #define ALPHA				0x6FFF //0x2666
  #define ALPHA_1		   (0x7FFF - ALPHA)
#endif
Flag Overflow = 0;
Flag Carry    = 0;


#define MAX_32 (Word32)0x7fffffffL
#define MIN_32 (Word32)0x80000000L

#define MAX_16 (Word16)0x7fff
#define MIN_16 (Word16)0x8000

extern JitBuffType_  SMMJitBuff[MAX_VOICE_CHANNELS];
extern Word16   AJB_ISR_SCHEDULER_DURATION[MAX_VOICE_CHANNELS];
extern uWord16   AJB_READ_THRESHOLD[MAX_VOICE_CHANNELS];

extern uWord16   AJB_AllowNullPlayPassFailCnt[MAX_VOICE_CHANNELS];
extern uWord16   AJB_AllowNullPlayPassFailCntThr[MAX_VOICE_CHANNELS];

extern Markov4StateType_  Markov4Data[MAX_VOICE_CHANNELS];
extern VQMonRtcpXR_Type_  VQMonRtcpXR_Data[MAX_VOICE_CHANNELS];
//-------------------DELAY ESTIMATION MODULE TIMERS--------------------
uWord16   AJB_DELAY_EST_TIMER[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------

//---------------------SIGMA FACTORS-----------------------------------
//---> Delay Estimation -SigmaFactor
uWord16   AJB_DELAY_EST_SIGMA_FACTOR[MAX_VOICE_CHANNELS];
//---> Gap Estimation ->SigmaFactor
uWord16   AJB_GAP_DELAY_EST_SIGMA_FACTOR[MAX_VOICE_CHANNELS];
//---> Delay TrackDowm -SigmaFactor
uWord16   AJB_DELAY_TRACK_SIGMA_FACTOR[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------

//--> Estimation Module Limits-----------------------------------------
uWord16   AJB_MIN_DELAY_MS[MAX_VOICE_CHANNELS];
uWord16   AJB_MAX_DELAY_MS[MAX_VOICE_CHANNELS];
uWord16   AJB_DEL_OFFSET_MS[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------


//------------Allowed Max No of   Packet drops per one entry-----------
uWord16   AJB_ALLOW_PKT_DROP_PER_SLOT[MAX_VOICE_CHANNELS];
uWord16   AJB_ALLOW_NULLS_PER_SLOT[AJB_MAX_NO_OF_DELAY_LEVELS];
uWord16   AJB_TOTAL_PKTS_PER_SLOT[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------

//---> Delay Drop Timer---------
uWord16   AJB_DELAY_DROP_TIMER[MAX_VOICE_CHANNELS];


/********************************************************************
* Function         : JitDelayTrack()                                *
* I/P Parameters   : PortNum                                        *
* O/P Parameters   : NONE                                           *
* Description      : This function has following functionality.     *
*     1.Delay estimation by spike detection Varience control and    *
*       late packet drop gap-concealment.                           *
*     2.AJB counters set and resetting.                             *
*     3.AJB Buffers re-sizing w.r.t delay estimation.               *
********************************************************************/
void JitDelayTrack( uWord16 PortNum)
{
  Word16  JitVarience,JitStep,JitSign;
  Word16  LoopNotSafe = 0,CurWtDelay;
  Word16  JitBufSize;
  Word16  JitGap;    

  /****************************************************************
     Update All Timers.
  ****************************************************************/
  SMMJitBuff[PortNum].JitDelayEstTimer        += 1;
  SMMJitBuff[PortNum].DelayDropTimer          += 1;

  /***************************************************************
    DELAY ESTIMATION UPDATE WITH SPIKE DETECTION &GAP ESTIMATION
  ****************************************************************/
#ifdef  JIT_SPIKE_DETECTION
  if( SMMJitBuff[PortNum].JitDelayEstTimer > 
                                    AJB_DELAY_EST_TIMER[PortNum])
  {
    JitSign = 1;
    JitBufSize = (SMMJitBuff[PortNum].ListCellCnt 
                      *  SMMJitBuff[PortNum].DelRemStepMS);
    if( SMMJitBuff[PortNum].MaxDelay  >
                         SMMJitBuff[PortNum].ReadThreshold )
    {
      JitVarience = SMMJitBuff[PortNum].MaxDelay  - 
                         SMMJitBuff[PortNum].ReadThreshold;
      JitSign = -1;
    }
    else if( SMMJitBuff[PortNum].MaxDelay  <
		         SMMJitBuff[PortNum].ReadThreshold )
    {
      JitVarience  =  SMMJitBuff[PortNum].ReadThreshold - 
                         SMMJitBuff[PortNum].MaxDelay;
    }
    else
      JitVarience = 0;

    /*   JIT STEP ESTIMATION  */
    if(JitVarience > 0 )
      JitStep =  ( JitVarience / 10) + 1;
    else
      JitStep = 0;
    SMMJitBuff[PortNum].MaxDelay +=  (JitSign *JitStep);
    CurWtDelay     = SMMJitBuff[PortNum].MaxDelay + 
           (SMMJitBuff[PortNum].MaxDelay * 
	             AJB_DELAY_EST_SIGMA_FACTOR[PortNum] )/100;

    /*   GAP ESTIMATION    */
    JitGap =   SMMJitBuff[PortNum].DelRemStepMS *
       (SMMJitBuff[PortNum].LateDropCnt - 
                           SMMJitBuff[PortNum].PreLateDropCnt);
    if( JitGap < 0 )
      JitGap = 0;
    SMMJitBuff[PortNum].PreLateDropCnt = 
                               SMMJitBuff[PortNum].LateDropCnt;
    /*  SPIKE ESTIMATION > < OR > <  GAP ESTIMATION >  */

#ifdef AJB_GAP_OFFSET_ENABLE
    SMMJitBuff[PortNum].GapOffset  =  0;
    if( JitGap >  0 )
    {	 
      if( CurWtDelay > SMMJitBuff[PortNum].CurWtDelay  )
      {   
        JitStep = (CurWtDelay - SMMJitBuff[PortNum].CurWtDelay);
        if( JitGap > JitStep )
        {
          /* Gap is greater than Estimation */
          SMMJitBuff[PortNum].CurWtDelay = CurWtDelay;
	  JitStep =  JitGap - JitStep;
	}
        else
          JitStep = 0;/* if Gap is greater than zero Don't 
                         decrese delayEst. */
      }
      else
      { 
        /*  CurWtDelay < PreCurWtDelay. */
        JitStep =  JitGap;
      }
      JitStep =  ( AJB_GAP_DELAY_EST_SIGMA_FACTOR[PortNum] * 
                                                 JitStep )/100;
      SMMJitBuff[PortNum].GapOffset  = JitStep;
    }
    else
    {	 
      /*  Gap is not Greater Than Zero. */
      SMMJitBuff[PortNum].CurWtDelay = CurWtDelay;  
    }
#else 
//---> #ifdef AJB_GAP_OFFSET_ENABLE
    SMMJitBuff[PortNum].CurWtDelay  =  CurWtDelay;
    SMMJitBuff[PortNum].GapOffset   =  0;
#endif 

    /*  CONSIDER LATE PACKET DROP GAP-Threshold. */
    JitStep =  SMMJitBuff[PortNum].CurWtDelay +
                             SMMJitBuff[PortNum].GapOffset;

    if( JitStep < AJB_MIN_DELAY_MS[PortNum] )
      JitStep = AJB_MIN_DELAY_MS[PortNum];
    if( JitStep > AJB_MAX_DELAY_MS[PortNum] )
      JitStep = AJB_MAX_DELAY_MS[PortNum];
	 
    AJB_READ_THRESHOLD[PortNum] = 
             (JitStep/ SMMJitBuff[PortNum].DelRemStepMS);

    SMMJitBuff[PortNum].JitDelayEstTimer = 0; //--> Reset Timer.
  }
#endif
   

#ifdef JIT_DELAY_TRACK
  if( SMMJitBuff[PortNum].DelayDropTimer > 
                             AJB_DELAY_DROP_TIMER[PortNum])
  {
	SMMJitBuff[PortNum].DelayDropTimer =
		                             AJB_DELAY_DROP_TIMER[PortNum]+1; /* IKANOS- 07/20/07 */
    /*********************************************************
       Don't do any delay track drops, if packet play out is 
       not good
    *********************************************************/
    if( AJB_AllowNullPlayPassFailCnt[PortNum]  > DEF_AJB_ALLOW_NULL_PLAY_PASS_FAIL_CNT_THR )/* IKANOS- 07/20/07 */
	 
    { 
      SMMJitBuff[PortNum].DelayDropTimer   = 0;  //---> Reset Timer
      /* return; */ /* IKANOS- 07/20/07 */
    }

    JitStep =  AJB_READ_THRESHOLD[PortNum] + 
                                  SMMJitBuff[PortNum].RxFrameCntr -1;
    JitStep = JitStep + (JitStep * AJB_DELAY_TRACK_SIGMA_FACTOR[PortNum])/100;

    while( SMMJitBuff[PortNum].ListCellCnt > JitStep )
    {
      JitBufSize = SMMJitBuff[PortNum].ListCellCnt;
      RdJitBuffer(PortNum);
      SMMJitBuff[PortNum].RxPktProp      = 0;
      if( JitBufSize > SMMJitBuff[PortNum].ListCellCnt )
      { 
#if AJB_ENABLE_STATISTICS
        /* if it able Drop the Packet Set the Cntr. */
        SMMJitBuff[PortNum].DelayTrackPktDropCnt   += 1;
        SMMJitBuff[PortNum].DelayTrackFreqCntr     +=  1;
#endif
      }	 
      else
        break;
      LoopNotSafe++;
      if( LoopNotSafe > AJB_ALLOW_PKT_DROP_PER_SLOT[PortNum] )
        break;
    } //----> End of while Loop.
   
    SMMJitBuff[PortNum].DelayDropTimer   = 0;  //---> Rset Timer
  }
#endif
}

#ifdef JIT_DELAY_ESTIMATION
/********************************************************************
* Function       :JitDelayEst                                       *
* Return Values  :NONE                                              *
* Description     This function contains implementation of Delay    *
                  Estimation and there by fixing of read threshold. *
********************************************************************/
void JitDelayEst(WtRtpPktType_ *WtRTPPktPtr , uWord16 PortNum )
{   
  Word32  Term1,Term2,Term3;
  Word16   nd, p_hat;

  /**********************************************************
    //---> Relative Transit Time calculation for this Packet. 
  **********************************************************/
  Term1 =  WtRTPPktPtr->RR_TIMESTAMP - 
           SMMJitBuff[PortNum].RR_TIMESTAMP;

  Term2 =  WtRTPPktPtr->SR_TIMESTAMP - 
           SMMJitBuff[PortNum].SR_TIMESTAMP;     

  Term3 = Term1 - Term2;
  SMMJitBuff[PortNum].EstCumJit32  +=  Term3;

  /***********************************************************
            Relative Transit Time.
    1. Inter Arrival Jitter = 
                    MeanDeviation(Relative Transit Time)
    2. Below Operation is Optimal First Order Estimator
    3. Gain = 1/16, Gives Good Noise reduction ratio	         
  ***********************************************************/
  SMMJitBuff[PortNum].EstCumJit = 
                      (Word16)SMMJitBuff[PortNum].EstCumJit32;

  /***********************************************************
      EstInitJit =   15/16 * EstInitJit + 1/16 * EstCumJit
	  15/16 ----> 0x77FF
	   1/16 ----> 0x7FF
  ***********************************************************/
#define JIT_CUM_JIT_WT     0x77FF
#define JIT_CUM_JIT_WT_1  (0x7FFF - JIT_CUM_JIT_WT)

  Term1 =    15 * (SMMJitBuff[PortNum].EstInitJit >> 4) ;
  Term2 =     SMMJitBuff[PortNum].EstCumJit32 >> 4;
  Term3 =  L_add ( Term1, Term2);
  SMMJitBuff[PortNum].EstInitJit  =  Term3;
  nd = JIT_RTCP_ONE_WAY + 
         (Word16)(SMMJitBuff[PortNum].EstCumJit32 -
	                          SMMJitBuff[PortNum].EstInitJit);

  /***********************************************************
  ---> Update Delay Mean, with weighting function as per Ramjee.
       d_hat =  ALPHA * d_hat + ( 1-ALPHA ) * nd
  ***********************************************************/
  Term1 = L_mult(ALPHA,SMMJitBuff[PortNum].d_hat_prev);
  Term2 = L_mult(ALPHA_1,nd);
  Term3 = L_add(Term1,Term2);
  Term3 = L_shr(Term3,16);
  SMMJitBuff[PortNum].d_hat = (Word16) Term3;


  /***********************************************************
      |---> Update Delay Varience, with weighting function.   
	  v_hat = ALPHA * v_hat  + ( 1- ALPHA ) abs( d_hat - nd )
  ***********************************************************/
  Term1 = L_mult(ALPHA, SMMJitBuff[PortNum].v_hat_prev);	
  Term2 = L_mult(ALPHA_1, Jit_abs_s( SMMJitBuff[PortNum].d_hat - nd));
  Term3 = L_add(Term1, Term2);
  Term3 = L_shr(Term3,16);
  SMMJitBuff[PortNum].v_hat = (Word16) Term3;


   /* ---> Current Packet encountered Delay  */
  p_hat = SMMJitBuff[PortNum].d_hat +  4 * SMMJitBuff[PortNum].v_hat;
  if( p_hat < 0 )
  {
    if( p_hat == -32768 )
      p_hat = 0x7FFF;
    else 
      p_hat = -p_hat;
  }

  /* -------> APPLY LAG ON DELAY ESTIMATOR.  */
  Term1 = L_mult(0x0ccc, p_hat);
  Term2 = L_mult(0x7332, SMMJitBuff[PortNum].p_hat);
  Term3 = L_add(Term1,Term2);
  Term3 = L_shr(Term3,16);
  SMMJitBuff[PortNum].p_hat = (Word16) Term3;

  //---> End of Delay Tracking Slope control.
  SMMJitBuff[PortNum].d_hat_prev 	=  SMMJitBuff[PortNum].d_hat;
  SMMJitBuff[PortNum].v_hat_prev   =  SMMJitBuff[PortNum].v_hat;
  SMMJitBuff[PortNum].nd_2    =     SMMJitBuff[PortNum].nd_prev;
  SMMJitBuff[PortNum].nd_prev   =  nd;	  	  
  SMMJitBuff[PortNum].RR_TIMESTAMP   = WtRTPPktPtr->RR_TIMESTAMP;
  SMMJitBuff[PortNum].SR_TIMESTAMP   = WtRTPPktPtr->SR_TIMESTAMP;
     
  /*---> Find the DelatEstimate in milli seconds. */
  SMMJitBuff[PortNum].ReadThreshold =
     (SMMJitBuff[PortNum].p_hat + AJB_DEL_OFFSET_MS[PortNum])
                                    /AJB_PCM_NO_OF_SAMPLES_PER_1MS;

  /*--> SET UPPER MARK  */
  if( SMMJitBuff[PortNum].ReadThreshold  > AJB_MAX_DELAY_MS[PortNum])
    SMMJitBuff[PortNum].ReadThreshold = AJB_MAX_DELAY_MS[PortNum];

  /*--> SET LOWER MARK  */
  if( SMMJitBuff[PortNum].ReadThreshold  <  AJB_MIN_DELAY_MS[PortNum] )
    SMMJitBuff[PortNum].ReadThreshold = AJB_MIN_DELAY_MS[PortNum];
}//--> End of JitDelayEstimation.





/********************************************************************
						L_mult
********************************************************************/
Word32 L_mult(Word16 var1,Word16 var2)
{
   Word32 L_var_out;

   L_var_out = (Word32)var1 * (Word32)var2;
   if (L_var_out != (Word32)0x40000000L)
     {
      L_var_out *= 2;
     }
   else
     {
      Overflow = 1;
      L_var_out = MAX_32;
     }

   return(L_var_out);
}




/********************************************************************
						L_add
********************************************************************/
Word32 L_add(Word32 L_var1, Word32 L_var2)
{
   Word32 L_var_out;

   L_var_out = L_var1 + L_var2;

   if (((L_var1 ^ L_var2) & MIN_32) == 0)
  {
      if ((L_var_out ^ L_var1) & MIN_32)
    {
         L_var_out = (L_var1 < 0) ? MIN_32 : MAX_32;
         Overflow = 1;
        }
     }
   return(L_var_out);
}





/********************************************************************
						L_shr
********************************************************************/
Word32 L_shr(Word32 L_var1, Word16 var2)
{
   Word32 L_var_out;

   if (var2 < 0)
     {
      L_var_out = (Word32) L_shl((Word32)L_var1,(Word16)-var2);
       }
       else
       {
      if (var2 >= 31)
        {
         L_var_out = (L_var1 < 0L) ? -1 : 0;
       }
      else
        {
         if (L_var1<0)
           {
            L_var_out = ~((~L_var1) >> var2);
    }
        else
 {
           L_var_out = L_var1 >> var2;
 }
        }
     }
   return(L_var_out);
}




/********************************************************************
				   abs_s
********************************************************************/
Word16 Jit_abs_s(Word16 var1)
{
   Word16 var_out;

   if (var1 == (Word16)0X8000 )
     {
      var_out = MAX_16;
     }
   else
     {
      if (var1 < 0)
        {
         var_out = -var1;
        }
      else
        {
         var_out = var1;
        }
      }
    return(var_out);
}



/********************************************************************
				       L_sub
********************************************************************/
Word32 L_sub(Word32 L_var1, Word32 L_var2)
{
   Word32 L_var_out;

   L_var_out = L_var1 - L_var2;

   if (((L_var1 ^ L_var2) & MIN_32) != 0)
     {
      if ((L_var_out ^ L_var1) & MIN_32)
        {
         L_var_out = (L_var1 < 0L) ? MIN_32 : MAX_32;
         Overflow = 1;
        }
     }
   return(L_var_out);
}




/********************************************************************
				             L_shl
********************************************************************/
Word32 L_shl(Word32 L_var1, Word16 var2)
{
   Word32 L_var_out;

   /* initialization used only to suppress Microsoft Visual C++ warnings */
   L_var_out = 0L;

   if (var2 <= 0)
     {
      L_var_out = (Word32) L_shr((Word32)L_var1,(Word16)-var2);
     }
   else
     {
      for(;var2>0;var2--)
        {
         if (L_var1 > (Word32) 0X3fffffffL)
           {
            Overflow = 1;
            L_var_out = MAX_32;
            break;
           }
         else
           {
            if (L_var1 < (Word32) 0xc0000000L)
              {
               Overflow = 1;
               L_var_out = MIN_32;
               break;
              }
           }
         L_var1 *= 2;
         L_var_out = L_var1;
        }
     }
   return(L_var_out);
}
#endif  

/*---------------------------------------------------------------------
               //---> VQT MARKO-4Estimations
---------------------------------------------------------------------*/
void Markov4Est(uWord16 PortNum)
{
 //-------------------------------------------------> Null Packet case.
 Markov4Data[PortNum].BurstFreqCntr_c5  += Markov4Data[PortNum].RxPktCnt;

 if( Markov4Data[PortNum].RxPktCnt >= GMin )
 {
 /*
   ---------------------------- GAP - ZONE-----------------------------
 */
  if( Markov4Data[PortNum].RxLostPktCnt == 1 )//&&
									//( Markov4Data[PortNum].c13 != 0 ))
  {
	  Markov4Data[PortNum].c14 += 1;
	  Markov4Data[PortNum].MARKOV4STATE = MARKOV4STATE4;
  }
  else
  {
	  Markov4Data[PortNum].c13 += 1;
	  Markov4Data[PortNum].MARKOV4STATE = MARKOV4STATE3;
    }

  Markov4Data[PortNum].RxLostPktCnt = 1;
  Markov4Data[PortNum].c11 += Markov4Data[PortNum].RxPktCnt;
/*
   ---------------------END  GAP - ZONE--------------------------------
 */
 }else
 {
/*
   ----------------------- BURUST - ZONE-------------------------------
*/
   Markov4Data[PortNum].RxLostPktCnt += 1;
  
   if( Markov4Data[PortNum].RxLostPktCnt > MARKOV4_ESTI_SIG_LOST )
      Markov4Data[PortNum].BurstFreqCntr_c5 = 0;  
    
   if(Markov4Data[PortNum].RxPktCnt == 0 )
   { 
	   Markov4Data[PortNum].c33 += 1;
	   Markov4Data[PortNum].MARKOV4STATE = MARKOV4STATE3;
   }else
   {
       Markov4Data[PortNum].c23 += 1;	   
	   Markov4Data[PortNum].c22 += Markov4Data[PortNum].RxPktCnt;
	   Markov4Data[PortNum].MARKOV4STATE = MARKOV4STATE2;
   } 
/*
  ----------------------END BURUST - ZONE------------------------------
*/
  if( Markov4Data[PortNum].PLCEnaDisFlag ==  AJB_PLC_ENA )
    Markov4Data[PortNum].c11 = Markov4Data[PortNum].c11 
	                                    + Markov4Data[PortNum].c14;

 }//---> end of else of GMin.
}
/*---------------------------------------------------------------------
              //---> VQT MARKO-4Estimations
---------------------------------------------------------------------*/

		
#if 0
	
/*---------------------------------------------------------------------
              //---> VQMonPktMetrics()
---------------------------------------------------------------------*/
void VQMonPktMetrics(uWord16 PortNum)
{
 uWord32 C31, C32, D,uTemp32_4;
 uWord16 Fact, P13,P23, P3, P31, P32;
 uWord32 uTemp32,uTemp32_1,uTemp32_2,uTemp32_3;
 Word32  RModeIeCoef1=0, RModeIeCoef2=0,RModeIeCoef3=0,Temp32_1=0;
 Word32  Temp32_2,Temp32_3,Temp32,OneWayDelay;
 Word16  AvePktLossRateAbs,Temp16_1,Temp16_2;


 if(SMMJitBuff[PortNum].JitInitFlag  < 2 )
   return;

#if 0 // ndef AJB_SIMULATION
if( guiRoundTripDelay[PortNum] >= 65535 )
   Markov4Data[PortNum].RoundTripDelay = 0xFFFF;
else
   Markov4Data[PortNum].RoundTripDelay = guiRoundTripDelay[PortNum];
#endif


#if 1

/*---------------------------------------------------------------------
1.GAP Length = [(C11 + C14 + C13 ) * m ]/C13;  { Limit to 16 Bit }
2.BURUST Length = m *(C22 + C23 + C31 + C32 + C33 ) / C13{Limit to 16Bit}
-----------------------------------------------------------------------
3.GAP Density = ( 256 * C14 )/  (C11 + C14 )
4.Burust Density = 256 * P23/(P23 + P32)
---------------------------------------------------------------------*/
C31 = Markov4Data[PortNum].c13;
C32 = Markov4Data[PortNum].c23;

//--> BurustLenNum
uTemp32 = Markov4Data[PortNum].c22  + Markov4Data[PortNum].c23 +
			                     C31  + C32 + Markov4Data[PortNum].c33;


if( Markov4Data[PortNum].PLCEnaDisFlag ==  AJB_PLC_ENA )
{ //-->  GapLen-Num
   uTemp32_1 =  ( Markov4Data[PortNum].c11 + Markov4Data[PortNum].c13);
   //---> Gap Denisty Denom
   uTemp32_2 =  Markov4Data[PortNum].c11;
 //-----> End of PLC Enable Case
}else
{
 //----> PLC Disable Case
 //-->  GapLen-Num
 uTemp32_1 =  (Markov4Data[PortNum].c11 + Markov4Data[PortNum].c13 +
		      Markov4Data[PortNum].c14);
 //---> Gap Denisty Denom
  uTemp32_2 =  Markov4Data[PortNum].c11 + Markov4Data[PortNum].c14;
}

uTemp32_4 = uTemp32_1;

//1.GAP Length = [(C11 + C14 + C13 ) * m ]/C13;  { Limit to 16 Bit }
//2.BURUST Length = m * (C22 + C23 + C31 + C32 + C33 ) / C13{ Limit to 16 Bit }
if( Markov4Data[PortNum].c13 == 0 )
{
  if((Markov4Data[PortNum].MARKOV4STATE == 1)||
							( Markov4Data[PortNum].MARKOV4STATE == 4 ))
		{
	  Markov4Data[PortNum].GapLength   =  0; 
      Markov4Data[PortNum].BurustLength = 0;
  }else
  {	 
      Markov4Data[PortNum].GapLength    = 0; 
      Markov4Data[PortNum].BurustLength = 0; 
		}

}else
{    
  uTemp32_1	= uTemp32_1 / Markov4Data[PortNum].c13;
  if( uTemp32_1 > 0xFFFF )
    uTemp32_1 = 0xFFFF;
  uTemp32_1 = uTemp32_1 * Markov4Data[PortNum].FrameSizeMS;
  if( uTemp32_1 > 0xFFFF )
    uTemp32_1 = 0xFFFF;
  

  //---> BurustLength
  uTemp32	= uTemp32 / Markov4Data[PortNum].c13;
  uTemp32 = uTemp32 *Markov4Data[PortNum].FrameSizeMS;
  if( uTemp32 > 0xFFFF )
    uTemp32 = 0xFFFF;
               
  if((Markov4Data[PortNum].MARKOV4STATE == 1)||
	                             (Markov4Data[PortNum].MARKOV4STATE == 4))
  { 
	  Markov4Data[PortNum].GapLength = (uWord16)uTemp32_1;
      Markov4Data[PortNum].BurustLength = 0; 
  }else
  {   
	  Markov4Data[PortNum].GapLength = 0; 
      Markov4Data[PortNum].BurustLength = (uWord16) uTemp32;
  }

}

//3.GAP Density = ( 256 * C14 )/  (C11 + C14 )
if( uTemp32_2 == 0 )
{
  Markov4Data[PortNum].GapLossDensity = (UCHAR)0; 
}else
{
  if( uTemp32_2 >= 256 ) 
  {
	  uTemp32_2 = uTemp32_2 >> 8;
      uTemp32_2 = Markov4Data[PortNum].c14 / uTemp32_2;
  }else
  {     
     uTemp32_2 = ( Markov4Data[PortNum].c14 << 8 )/ uTemp32_2;
  }
  if ( uTemp32_2 > 255 )
	uTemp32_2 = 255;
  Markov4Data[PortNum].GapLossDensity = (UCHAR) uTemp32_2;
}
	

//----P1x  Probablities
if( uTemp32_4 == 0 )
  P13 = MARKOV4_PROB_NORM_MAX;
else
{
  if( uTemp32_4 >= MARKOV4_EXCITATION_CNTR_LIM  )
 {	  
   uTemp32_4 = uTemp32_4 >> 15;	   
   Fact =  1;
  }else
  {
   Fact =  MARKOV4_PROB_NORM_MAX;
 }
  P13 =  (uWord16)((uWord32)(Fact *  Markov4Data[PortNum].c13)/uTemp32_4);
}

//----P3x  Probablities
//4.Burust Density = 256 * P23/(P23 + P32)
uTemp32 = C31 + C32 + Markov4Data[PortNum].c33;
if( uTemp32 ==  0 )
{	
	P31 = MARKOV4_PROB_NORM_MAX;
	P32 = 0;
}else
{
 if( uTemp32 >= MARKOV4_EXCITATION_CNTR_LIM  )
 {   
   uTemp32 = uTemp32 >> 15;	   
   Fact =  1;
 }else
 { 
   Fact =  MARKOV4_PROB_NORM_MAX;
 }
 P31 =  (uWord16)((uWord32)(Fact * C31)/uTemp32);
 P32 =  (uWord16)((uWord32)(Fact * C32)/uTemp32);
}

//----P2x  Probablities
uTemp32 =  Markov4Data[PortNum].c22 + Markov4Data[PortNum].c23;
if( uTemp32 ==  0 )
{
	P23 = MARKOV4_PROB_NORM_MAX;
}else
{
 if( uTemp32 >= MARKOV4_EXCITATION_CNTR_LIM  )
 {
   uTemp32 = uTemp32 >> 15;	   
   Fact =  1;
 }else
 { 
   Fact =  MARKOV4_PROB_NORM_MAX;
 } 
 P23 =  (uWord16)((uWord32)(Fact * Markov4Data[PortNum].c23)/uTemp32);  
}
//4.Burust Density = 256 * P23/(P23 + P32)
uTemp32_1 = P23 << 8; 
uTemp32_1 = uTemp32_1 / (P23 + P32);
if( uTemp32_1 > 255 )
  uTemp32_1 = 255;
Markov4Data[PortNum].BurustLossDensity = (UCHAR)uTemp32_1;

if((Markov4Data[PortNum].MARKOV4STATE == 1)||(Markov4Data[PortNum].MARKOV4STATE == 4))
{ 
  Markov4Data[PortNum].BurustLossDensity = 0; //(UCHAR)uTemp32_1;
}else
  Markov4Data[PortNum].GapLossDensity    = 0;
	
/*---------------------------------------------------------------------
			1.Average Packet Loss rate in percent for R-Model
	    	2.Discard Rate in  255 Norm for rtcp-xr
            3.Nw Loss Rate in  255 Norm for rtcp-xr
---------------------------------------------------------------------*/


//----> Average Packet Loss rate.--------------------------------------
uTemp32_1 = (P23 * P31) >> 15;
uTemp32_2 = (P32 * P13) >> 15;
uTemp32_3 = (P23 * P13) >> 15;
D  =   uTemp32_1 + uTemp32_2  + uTemp32_3;
if( D == 0 )
  D = 1;

P3 = (uWord16)(uTemp32_3/D);
uTemp32  =  P3 >> 8;
uTemp32 =  (uWord16) (uTemp32 /MARKOV4_PROB_NORM_MAX);
if( uTemp32 > 255 )
   uTemp32  = 255;
Markov4Data[PortNum].AvePktLossRateProb  = (UCHAR) uTemp32;
//----> Average Packet Loss rate.--------------------------------------
#endif





//----> Average Packet Loss rate.--------------------------------------
//----> Discard  Packet Loss rate.-------------------------------------
//----> Network  Packet Loss rate.-------------------------------------                  

uTemp32_1 = SMMJitBuff[PortNum].DelayTrackPktDropCnt +
                                  SMMJitBuff[PortNum].RxLateDropPktCnt;
uTemp32_2 = SMMJitBuff[PortNum].RxNwLostPktCnt;
uTemp32_3 = SMMJitBuff[PortNum].RxNullPlayPktCnt;
uTemp32   = AJB_TOTAL_PKTS_PER_SLOT[PortNum];

if( uTemp32 >= 256 )
  uTemp32  = uTemp32 >> 8;  
else
{
  uTemp32_1 = uTemp32_1 << 8;
  uTemp32_2 = uTemp32_2 << 8;
  uTemp32_3 = uTemp32_3 << 8;
}

uTemp32_1    = uTemp32_1/ uTemp32;
uTemp32_2    = uTemp32_2/ uTemp32;
uTemp32_3    = uTemp32_3/ uTemp32;

if( uTemp32_1 > 255 )
	 uTemp32_1 = 255;
if( uTemp32_2 > 255 )
	 uTemp32_2 = 255;
if( uTemp32_3 > 255 )
	 uTemp32_3 = 255;

Markov4Data[PortNum].AveDisPktLossRate = (UCHAR) uTemp32_1;
Markov4Data[PortNum].AveNwPktLossRate  = (UCHAR) uTemp32_2;
Markov4Data[PortNum].AvePktLossRateAbs = (UCHAR) uTemp32_3;
//----> Discard  Packet Loss rate.-------------------------------------
//----> Network  Packet Loss rate.-------------------------------------
//----> Average Packet Loss rate.--------------------------------------



/*---------------------------------------------------------------------
	RATING_FACTOR-& EXTERNAL RATING FACTORS MODEL ESTIMATIONS
---------------------------------------------------------------------*/

#define R_MODEL_RO                                94
#define R_MODEL_SIMULTANEOUS_IMPAIRMENT_FACT_Is    0
#define R_MODEL_ADVANTAGE_FACTOR_A                 0
/*---------------------------------------------------------------------
R  = Ro - Is - Id - Ie + A
ro = 94~ 15 - 1.5(SENDER_LOUDNESS_RATING~7 + No~TotalNoisePower~-60).
TotalNoisePower = 10Log{ 10Pow(CircuitNoise/10) + 10Pow(SenderRoom Noise/10
                        +10Pow(receiverRoomNoise) +10Pow(RxNoiseFloor) }
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
Is = R_MODEL_SIMULTANEOUS_IMPAIRMENT_FACT = Iolr + Ist + Iq
     Iolr~OVERALL_LOUDNESS_RATING : 10 dB { Telephone + NWLoss }
     Ist ~SIDE_TONE_MASK_RATING   : 15 dB { Telephone Instrument }
	 Iq  ~QUANTIZATION_DISTORTION_UNITS: 1 

Id =  Idte + Idle + Idd 
     Idte~if( TALKER_ECHO_LOUDNESS_RATING  ==  65 dB (Min:6dB)) 
			Condier the  ONE_WAY_DELAY
		else 
		    Condier the Effect of EchoCan ON/Off + Delay
	 Idle~WEIGHTED_ECHO_PATH_LOSS  : 110 dB

A  : R_MODEL_ADVANTAGE_FACTOR~0
-----------------------------------------------------------------------
case G711:  Ie = 0.0037*(L*L*L) - 0.1376*(L*L) + 3.4978*L +  0.6663;
case G726:  Ie = 0.0037*(L*L*L) - 0.1376*(L*L) + 3.4978*L +  0.6663;
case G729:  Ie = 0.0051*(L*L*L) - 0.2197*(L*L) + 4.5869*L + 10.7880;
case G723:  Ie = 0.0087*(L*L*L) - 0.3094*(L*L) + 5.2348*L + 14.5982;
-----------------------------------------------------------------------
ONE_WAY_END_SYSTEM_DELAY_MS = Oneway Network Delay + Codec Delay  + A/D
                           + D/A + System Processing Delays.
if(( ONE_WAY_END_SYSTEM_DELAY_MS - 177.3) > 0.0 )
   Id =  (0.024*ONE_WAY_END_SYSTEM_DELAY_MS)   + 
	                           0.11*(ONE_WAY_END_SYSTEM_DELAY_MS-177.3);
else
   Id =  0.024*ONE_WAY_END_SYSTEM_DELAY_MS;
-----------------------------------------------------------------------
   RATING FACTOR					TO
						MEAN OPENION SCORE- LISTERNS_QUALITY( MOS-LQ)
   EXTERNAL_RATING FACTOR			TO 
				MEAN OPENION SCORE- CONVERSASITIONAL_QUALITY( MOS-CQ)
-----------------------------------------------------------------------
 For R<0:		MOS = 1
 For 0<R<100	MOS = 1 + 0.035 R + R( R - 60 )(100 - R)0.000007  
 For R>100		MOS = 4.5
---------------------------------------------------------------------*/
AvePktLossRateAbs = 
        ((Word16)Markov4Data[PortNum].AvePktLossRateAbs * 100 ) >> 8;

switch(SMMJitBuff[PortNum].CodecIePolyIndex)
{
 case 0 :
 RModeIeCoef1 = 37;
 RModeIeCoef2 = -1376;
 RModeIeCoef3 = 34978; 
 break;
	  
 case 1 :
 RModeIeCoef1 = 51;
 RModeIeCoef2 = -2197;
 RModeIeCoef3 = 45869;
 break;
	  
 case 2 :
 RModeIeCoef1 = 87;
 RModeIeCoef2 = 3094;
 RModeIeCoef3 = 52348;
 break;


 default:
 printk("\r\nR-ModelEstErr:CodecMismatch");
 break;
}

Temp32_1 = 
	RModeIeCoef1 * AvePktLossRateAbs * AvePktLossRateAbs * AvePktLossRateAbs;
Temp32_2 =  
    RModeIeCoef2 * AvePktLossRateAbs * AvePktLossRateAbs;
Temp32_3 =  
    RModeIeCoef3 * AvePktLossRateAbs;

Temp32 =  (Temp32_1 + Temp32_2 + Temp32_3 + 
	                SMMJitBuff[PortNum].CodecIeOffset)/R_MODEL_IE_DIV_FACTOR;
  
if( Temp32  >  44 )
  Markov4Data[PortNum].Est_Ie = (UCHAR)44;
else if( Temp32  <  0 )
  Markov4Data[PortNum].Est_Ie = (UCHAR)0;
else
  Markov4Data[PortNum].Est_Ie = (UCHAR) Temp32;

Markov4Data[PortNum].Rating_Factor = 
         (UCHAR) (RATING_FACTOR_MAX - Markov4Data[PortNum].Est_Ie);

/*
                  CONVERT RATING FACTOR TO MOS
*/

Temp16_1  =  (Word16)Markov4Data[PortNum].Rating_Factor - 60;
Temp16_2  =  100 - (Word16)Markov4Data[PortNum].Rating_Factor;

Temp32_1  =  R_MODEL_R_TO_MOS_COEF1 * Markov4Data[PortNum].Rating_Factor;
Temp32_2  =  R_MODEL_R_TO_MOS_COEF2 * Markov4Data[PortNum].Rating_Factor * 
                        Temp16_1 * Temp16_2;
Temp32    =  
  (R_MODEL_R_TO_MOS_OFFSET + Temp32_1 + Temp32_2)/R_MODEL_R_TO_MOS_DIV_FACTOR;
/*---------------------------------------------------------------------
 For R<0:		MOS = 1
 For 0<R<100	MOS = 1 + 0.035 R + R( R - 60 )(100 - R)0.000007  
 For R>100		MOS = 4.5
---------------------------------------------------------------------*/
if( Temp32 <= 10 )
 Markov4Data[PortNum].MOS_LQ = (UCHAR)10;
else if( Temp32 > 50 )
 Markov4Data[PortNum].MOS_LQ = (UCHAR)50;
else
 Markov4Data[PortNum].MOS_LQ = (UCHAR)Temp32;


/*---------------------------------------------------------------------
                ESTIMATION OF DELAYED IMPAIRMENTS -Id  
-----------------------------------------------------------------------
 Id = Idte + Idle + Idd
 1.Idte --> Impairment due to Talker  Echo.
            Idte = f( One way Delay Imp , TalkerEchoImp )
			       One way Delay Imp =  1- exp(-Oneway Delay) )
                    
 2.Idle --> Impairment due to Listner Echo.
            = f ( Round Trip Delay , weighted Echo path Loss )
 2.Idd  --> Impairment due to Too Long Absolute Delay.            
----------------------------------------------------------------------- 
ONE_WAY_END_SYSTEM_DELAY_MS = Oneway Network Delay + Codec Delay  + A/D
                           + D/A + System Processing Delays.
----------------------------------------------------------------------- 
if(( ONE_WAY_END_SYSTEM_DELAY_MS - 177.3) > 0.0 )
   Id =  (0.024*ONE_WAY_END_SYSTEM_DELAY_MS)   + 
	                           0.11*(ONE_WAY_END_SYSTEM_DELAY_MS-177.3);
else
   Id =  0.024*ONE_WAY_END_SYSTEM_DELAY_MS;
---------------------------------------------------------------------*/
//----- ABSOLUTE DELAY ESTIMATE
OneWayDelay =
	SMMJitBuff[PortNum].ListCellCnt * SMMJitBuff[PortNum].DelRemStepMS;
Markov4Data[PortNum].JBCurrentDelay = (uWord16)OneWayDelay;

OneWayDelay = 10 * (OneWayDelay + IMPAIRMENT_DELAY_A2D_AND_D2A_OFFSET_MS);
if( OneWayDelay >  1773 )
  Temp32  = (24 * OneWayDelay + 110 * ( OneWayDelay - 1773 ))/10000;
else
  Temp32  = (24 * OneWayDelay )/10000;

/*---------------------------------------------------------------------
                END OF ESTIMATION OF DELAYED IMPAIRMENTS-Id
---------------------------------------------------------------------*/


//-------------EXTERNAL RATING FACTOR----------------------------------
Markov4Data[PortNum].Est_Id = (Word16) Temp32;
if( Temp32 <=  0 )
{
 Markov4Data[PortNum].Rating_FactorExt = 
	                                Markov4Data[PortNum].Rating_Factor;
}
else if( Temp32 > (Word32) Markov4Data[PortNum].Rating_Factor )
{
 Markov4Data[PortNum].Rating_FactorExt = 50;
}else
{
 Markov4Data[PortNum].Rating_FactorExt  = 
         (UCHAR)((Word32) Markov4Data[PortNum].Rating_Factor - Temp32);
}

if( Markov4Data[PortNum].Rating_FactorExt < 50 )
     Markov4Data[PortNum].Rating_FactorExt = 50;

/*---------------------------------------------------------------------
                  CONVERT EXTERNAL RATING FACTOR TO MOS
---------------------------------------------------------------------*/
Temp16_1  =  (Word16)Markov4Data[PortNum].Rating_FactorExt - 60;
Temp16_2  =  100 - (Word16)Markov4Data[PortNum].Rating_FactorExt;

Temp32_1  =  R_MODEL_R_TO_MOS_COEF1 * Markov4Data[PortNum].Rating_FactorExt;
Temp32_2  =  R_MODEL_R_TO_MOS_COEF2 * Markov4Data[PortNum].Rating_FactorExt * 
                        Temp16_1 * Temp16_2;
Temp32    =  
 (R_MODEL_R_TO_MOS_OFFSET + Temp32_1 + Temp32_2)/R_MODEL_R_TO_MOS_DIV_FACTOR;
/*---------------------------------------------------------------------
 For R<0:		MOS-CQ = 1
 For 0<R<100	MOS-CQ = 1 + 0.035 R + R( R - 60 )(100 - R)0.000007  
 For R>100		MOS-CQ = 4.5
---------------------------------------------------------------------*/
if( Temp32 <= 10 )
 Markov4Data[PortNum].MOS_CQ = (UCHAR)10;//--> Min
else if( Temp32 > 50 )
 Markov4Data[PortNum].MOS_CQ = (UCHAR)50; //--> Max
else
 Markov4Data[PortNum].MOS_CQ = (UCHAR)Temp32;//--BTW
/*---------------------------------------------------------------------
  END OF RATING FACTOR/EXT-R-FACTOR AND MOS-LQ/CQ MODEL ESTIMATIONS
---------------------------------------------------------------------*/
}
/*---------------------------------------------------------------------
              //--->End  of VQMonPktMetrics()
---------------------------------------------------------------------*/



#endif
/*---------------------------------------------------------------------
              MARKOV-4 State Inits
---------------------------------------------------------------------*/
void  Markov4EstInit(uWord16 PortNum , uWord16 RdFrameSize)
{
  Markov4Data[PortNum].PLCEnaDisFlag    =  AJB_PLC_ENA_DIS_FLAG;
  Markov4Data[PortNum].MARKOV4STATE     =  MARKOV4STATE1;
  Markov4Data[PortNum].RxPktCnt         =  0;
  Markov4Data[PortNum].RxLostPktCnt     =  0;

  Markov4Data[PortNum].c11              =  0;
  Markov4Data[PortNum].c13              =  0;
  Markov4Data[PortNum].c14              =  0;

  Markov4Data[PortNum].c22              =  0;
  Markov4Data[PortNum].c23              =  0;
  Markov4Data[PortNum].c33              =  0;
  Markov4Data[PortNum].BurstFreqCntr_c5 =  0;
  Markov4Data[PortNum].FrameSizeMS      =  RdFrameSize;
}
/*---------------------------------------------------------------------
         MARKOV-4 State Inits
---------------------------------------------------------------------*/



/*---------------------------------------------------------------------
         Build VQ-MON-rtcpxr Packet
---------------------------------------------------------------------*/
uWord16 BuildVQMonRtcpXRPkt(uWord16 PortNum, uWord32 Src_SSRCNum)
{
  UCHAR    *ucharPtr; //Buff[9];
  //uWord32  VQMonFrame[VQ_MON_RTCP_XR_BLOCK_LEN];
  uWord32  uTemp32_1;
  uWord32  uTemp32_2;
  uWord32  uTemp32_3;
  uWord32  uTemp32_4;
  Word16  i,j,k;

  uTemp32_1 = VQMON_RTCP_XR_BLOCK_TYPE; 
  VQMonRtcpXR_Data[PortNum].VQMonFrame[0] =
						((uTemp32_1 << 24)|( VQMON_RTCP_XR_BLOCK_LEN ));

  VQMonRtcpXR_Data[PortNum].VQMonFrame[1] = Src_SSRCNum;

  uTemp32_1 = (uWord32) Markov4Data[PortNum].AvePktLossRateAbs;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].AveDisPktLossRate;
  uTemp32_3 = (uWord32) Markov4Data[PortNum].BurustLossDensity;
  uTemp32_4 = (uWord32) Markov4Data[PortNum].GapLossDensity;
  VQMonRtcpXR_Data[PortNum].VQMonFrame[2] = 
	  ((uTemp32_1 << 24)|( uTemp32_2 << 16 ) | (uTemp32_3 << 8 ) |uTemp32_4);

  uTemp32_1 = (uWord32) Markov4Data[PortNum].BurustLength;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].GapLength;
  VQMonRtcpXR_Data[PortNum].VQMonFrame[3] = ((uTemp32_1 << 16)| uTemp32_2);

  uTemp32_1 = (uWord32) Markov4Data[PortNum].RoundTripDelay;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].JBCurrentDelay;
  VQMonRtcpXR_Data[PortNum].VQMonFrame[4] = ((uTemp32_1 << 16)| uTemp32_2);

  uTemp32_1 = (uWord32) Markov4Data[PortNum].SigLevel;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].NoiseLevel;
  uTemp32_3 = (uWord32) Markov4Data[PortNum].RERL;
  uTemp32_4 = (uWord32) GMin;
  VQMonRtcpXR_Data[PortNum].VQMonFrame[5] = 
	  ((uTemp32_1 << 24)|( uTemp32_2 << 16 ) | (uTemp32_3 << 8 ) |uTemp32_4);

  uTemp32_1 = (uWord32) Markov4Data[PortNum].Rating_Factor;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].Rating_FactorExt;
  uTemp32_3 = (uWord32) Markov4Data[PortNum].MOS_LQ;
  uTemp32_4 = (uWord32) Markov4Data[PortNum].MOS_CQ;
  VQMonRtcpXR_Data[PortNum].VQMonFrame[6] = 
	  ((uTemp32_1 << 24)|( uTemp32_2 << 16 ) | (uTemp32_3 << 8 ) |uTemp32_4);

  uTemp32_1 = (uWord32) Markov4Data[PortNum].RxConfig;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].JBNominalDelay;  
  VQMonRtcpXR_Data[PortNum].VQMonFrame[7] =((uTemp32_1 << 24)| uTemp32_2 );

  uTemp32_1 = (uWord32) Markov4Data[PortNum].JBCurrentDelay;
  uTemp32_2 = (uWord32) Markov4Data[PortNum].JBMaxDelay;
  VQMonRtcpXR_Data[PortNum].VQMonFrame[8] =((uTemp32_1 << 16)| uTemp32_2 );   

  k = 0;
  ucharPtr = (UCHAR *) &VQMonRtcpXR_Data[PortNum].VQMonFrame[0];

  for( i = 0; i < VQ_MON_RTCP_XR_BLOCK_LEN; i++ )
  {        
	for( j = 3; j >= 0; j-- )
	{  
       VQMonRtcpXR_Data[PortNum].VQMonRtcpXRBlock[k++] = *(ucharPtr+i*4 + j);
	}
  }

  return 1;//---> return Success.

}
/*---------------------------------------------------------------------
	    End of Build VQ-MON-rtcpxr Packet
---------------------------------------------------------------------*/

 /*-------------------------------------------------------------------
                     RESET DELAY ESTIMATION
 --------------------------------------------------------------------*/
void ResetDelayEst( WtRtpPktType_ *WtRTPPkt , uWord16 PortNum)
{
  //----> Reset-Delay Estimation Module
  SMMJitBuff[PortNum].RR_TIMESTAMP 
		        = WtRTPPkt->RR_TIMESTAMP;
  SMMJitBuff[PortNum].SR_TIMESTAMP 
		        = WtRTPPkt->SR_TIMESTAMP;
  SMMJitBuff[PortNum].EstCumJit     = 0;
  SMMJitBuff[PortNum].EstCumJit32   = 0;
  SMMJitBuff[PortNum].EstInitJit    = 0;
  SMMJitBuff[PortNum].d_hat_prev    = 0;
  SMMJitBuff[PortNum].v_hat_prev    = 0;
  SMMJitBuff[PortNum].nd_prev       = 0;
  SMMJitBuff[PortNum].nd_2          = 0;
  SMMJitBuff[PortNum].p_hat         = 0;
  SMMJitBuff[PortNum].ReadThreshold = 0;

  SMMJitBuff[PortNum].ResetDelayEstTimer = 0;
}

void InitDelayEst(uWord16 PortNum)
{
  UCHAR Plc_Mode;
  UCHAR JBType;
  UCHAR DelayStepSize;
  int i;

  //-------------------DELAY ESTIMATION MODULE TIMERS--------------------
  AJB_DELAY_EST_TIMER[PortNum] = DEF_AJB_DELAY_EST_TIMER;
  //---> Delay Estimation -SigmaFactor
  AJB_DELAY_EST_SIGMA_FACTOR[PortNum] = DEF_AJB_DELAY_EST_SIGMA_FACTOR;
  //---> Gap Estimation ->SigmaFactor
  AJB_GAP_DELAY_EST_SIGMA_FACTOR[PortNum] = DEF_AJB_GAP_DELAY_EST_SIGMA_FACTOR;
  //---> Delay TrackDowm -SigmaFactor
  AJB_DELAY_TRACK_SIGMA_FACTOR[PortNum] = DEF_AJB_DELAY_TRACK_SIGMA_FACTOR;

  //--> Estimation Module Limits-----------------------------------------
  AJB_MIN_DELAY_MS[PortNum]  =  confGetJitterThreshold();
  AJB_MAX_DELAY_MS[PortNum]  =  DEF_AJB_MAX_DELAY_MS;
  AJB_DEL_OFFSET_MS[PortNum]  =  DEF_AJB_DEL_OFFSET_MS;

  //---> Delay of AJB in terms of primary packet Cnt.
  AJB_READ_THRESHOLD[PortNum] =
       AJB_MIN_DELAY_MS[PortNum]/SMMJitBuff[PortNum].DelRemStepMS;

  Markov4Data[PortNum].JBNominalDelay = AJB_MIN_DELAY_MS[PortNum];
  Markov4Data[PortNum].JBMaxDelay     = AJB_MAX_DELAY_MS[PortNum];
  
  /*-----------------------------------------------------------------
    MARKOV-4 State Inits-----------------------------------------
  -----------------------------------------------------------------*/
  SMMJitBuff[PortNum].RxDelayTDropPktCnt = 0;
  SMMJitBuff[PortNum].RxLateDropPktCnt   = 0;
  SMMJitBuff[PortNum].RxNullPlayPktCnt   = 0;
  SMMJitBuff[PortNum].RxNwLostPktCnt     = 0;
  Plc_Mode       = MARKOV4_PLC_TYPE;
  if( MARKOV4_JB_TYPE >= 2 )
   JBType   = confGetJBType() + MARKOV4_JB_TYPE;
  else
   JBType = MARKOV4_JB_TYPE;
  DelayStepSize = 70 /SMMJitBuff[PortNum].DelRemStepMS;
  Markov4Data[PortNum].RxConfig = ((( Plc_Mode << 6 ) & 0xC0 )|
             (( JBType  << 4 ) & 0x30 )| ( DelayStepSize & 0x0F ));
  Markov4EstInit(PortNum , SMMJitBuff[PortNum].DelRemStepMS );
  //---------------------------------------------------------------------
 
  AJB_ALLOW_PKT_DROP_PER_SLOT[PortNum] = DEF_AJB_ALLOW_PKT_DROP_PER_SLOT;
  //---------------------PACKET DROPING CONTROLS-------------------------
  for( i = 0; i < AJB_MAX_NO_OF_DELAY_LEVELS; i++ )
  {
    AJB_ALLOW_NULLS_PER_SLOT[i] =  DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL1_DELAY;
  }

  AJB_TOTAL_PKTS_PER_SLOT[PortNum] =
        ( (DEF_AJB_STASTICS_RESET_TIMER) / SMMJitBuff[PortNum].DelRemStepMS);

   //---> Delay Drop Timer---------
  AJB_DELAY_DROP_TIMER[PortNum] =
       ( (DEF_AJB_DELAY_DROP_TIMER) / AJB_ISR_SCHEDULER_DURATION[PortNum]);

}
