
/**************************************************************************
 	Function Name: plc.c
	
        Modules : dofe,findpitch,savespeech,addtohistory,overlapadd,
				overlapaddatend,getfespeech,scalespeech.
	Description:   Main Plc algorithm modules.
 								
***************************************************************************/
#include <oswrapper.h>
#include "G711PLCCons.h"
#include "G711PLCBasic_op.h"
#include "G711pLcProto.h"
#include "G711pLcVar.h"

#if G711_PLC


/**************************************************************************
 	Function Name: 	dofe										  
	Description:   Generate the synthetic signal.
		       At the beginning of an erasure determine the pitch, and extract
		       one pitch period from the tail of the signal. Do an OLA for 1/4
		       of the pitch to smooth the signal. Then repeat the extracted signal
		       for the length of the erasure. If the erasure continues for more than
		       10 ms, increase the number of periods in the pitchbuffer. At the end
		       of an erasure, do an OLA with the start of the first good frame.
		       The gain decays as the erasure gets longer.
 					
 	Input Parameters:													   
			pointer to present frame 80 samples 
	return Values 													  
			none														
	Functions called
			copys
			findpitch
			overlapadd
			getfespeech
			scalespeech
			savespeech
***************************************************************************/
unsigned int Venkat5 = 0;
void G711PLC_dofe(void)
{
  Word16 i;
  Word16 G711PlcState = 0;
  short temp3_PLC,temp2_PLC;

/**************************************************************************    
          --->>> Find the  PLC State <<<---
***************************************************************************/
#if 1 //(FRAME_LEN == 80)	 
	 if ( EraseCnt ==(uWord16) 0)
         {
            G711PlcState  = G711PLC_STATE1;
            //printk("  1:=%d",EraseCnt);
         }
	 else
		 if( ( EraseCnt == 1 )|| ( EraseCnt == 2 ) )
                  {
		     G711PlcState  = G711PLC_STATE2;
                    //printk("  2:=%d",EraseCnt);
                   }
		 else 
		     if( ( EraseCnt ==3 )|| (  EraseCnt == 4)||( EraseCnt == 5 ))
                          {
                            //printk("  3:=%d",EraseCnt);   
			   G711PlcState  = G711PLC_STATE3;
                          }
		     else if ( EraseCnt > 5 )
                          {
                            //printk("  4:=%d",EraseCnt);
			   G711PlcState  = G711PLC_STATE4;
                          }
#endif

#if  0 //( ( FRAME_LEN == 40)||( FRAME_LEN == 44 ))	 

	if ( EraseCnt == 0)
       	    G711PlcState  = G711PLC_STATE1;
        else 
	   	if(( EraseCnt == 2)|| (  EraseCnt == 4))
		   G711PlcState  = G711PLC_STATE2;
	#if (FRAME_LEN == 44 )
	   	else if ( EraseCnt > 10 )
	   	   G711PlcState  = G711PLC_STATE4;
	#endif    

	#if (FRAME_LEN == 40 )
	        else if ( EraseCnt > 11 )
		   G711PlcState  = G711PLC_STATE4;
	#endif
	        else
		   G711PlcState  = G711PLC_STATE3;
#endif


/**************************************************************************    
          --->>> End of PLC State <<<---
***************************************************************************/

  switch( G711PlcState)
  {    
/**************************************************************************    
             --->>> First State <<--
***************************************************************************/
case 	G711PLC_STATE1 :
			//--->>>copy(SMM_History,SMM_PitchBuf,HISTORYLEN);
#if 1
#ifndef NORMALISATION

        for( i= 0; i < 110 ; i++ )
	{
		PitchBuffPtr[i]    = HistoryBuffPtr[ HistoryWtIndex++];
                HistoryWtIndex     = HistoryWtIndex % HISTORYLEN;
				
	}

	max = 0;
	for( i= 110; i < HISTORYLEN ; i++ )
	{
		PitchBuffPtr[i]    = HistoryBuffPtr[ HistoryWtIndex++];
                HistoryWtIndex     = HistoryWtIndex % HISTORYLEN;
		if ( max < abs_s_plc(PitchBuffPtr[i]) )  
			max = PitchBuffPtr[i];
	}
#else
	for( i= 0; i < HISTORYLEN ; i++ )
	{
		PitchBuffPtr[i]    = HistoryBuffPtr[ HistoryWtIndex++];
                HistoryWtIndex     = HistoryWtIndex % HISTORYLEN;
			
	}
#endif
	Venkat5++;			
	Pitch = findpitch(); /* find pitch */
			
	Pitch_overlap = Pitch >> 2; /* OLA 1/4 wavelength */
			
	/* save original last Pitch_overlap samples */
	copy( PitchBuffPtr + HISTORYLEN - Pitch_overlap, LastQBuffPtr, Pitch_overlap);
			
	Pitch_offset = 0; /* create pitch buffer with 1 period */
			
	PitchBlen = Pitch;			
			
	//----PitchBufStartPtr = PitchBufEndPtr - PitchBlen;			
	//--> OverLap and Add Block
	BuffPtr1 = LastQBuffPtr;
	BuffPtr2 = PitchBuffPtr + HISTORYLEN - PitchBlen - Pitch_overlap;
	BuffPtr3 = PitchBuffPtr + HISTORYLEN - Pitch_overlap;
	Temp1_plc    = Pitch_overlap;
			
	overlapadd();						
			
	//-->Update  the History Buffer with Updated Pitchbuffer updated samples.
	Temp1_plc = HistoryWtIndex - Pitch_overlap;						
	if(Temp1_plc < 0)				
	  Temp1_plc = Temp1_plc + HISTORYLEN;

	//-->  update last 1/4 wavelength in history buffer 			
	//copy( PitchBuffPtr + HISTORYLEN - Pitch_overlap, HistoryBuffPtr+ Temp1_plc,Pitch_overlap);
/****************************************************/
                        temp3_PLC=Temp1_plc;
			temp2_PLC=HISTORYLEN - Pitch_overlap;
			for(i=0;i<Pitch_overlap;i++)
			{
                          HistoryBuffPtr[temp3_PLC++]=PitchBuffPtr[temp2_PLC++];
			  temp3_PLC=temp3_PLC%HISTORYLEN;
			}

         /***************************************************/


	BuffPtr1 = speech;  //--> Argument 1
	Temp1_plc   = FRAME_LEN; //--> Argument 2
	getfespeech(); /* get synthesized speech */
#endif
	break;
		
/**************************************************************************    
   	       --->>> End of First State <<--
***************************************************************************/
/**************************************************************************
   	       --->>> Second State <<<---
***************************************************************************/
  case 	G711PLC_STATE2 :

#if 1
	
	/*--- tail of previous pitch estimate--- */
	saveoffset = Pitch_offset; /* save offset for OLA */

	BuffPtr1 = TempBuff;  //--> Argument 1
    	Temp1_plc    = Pitch_overlap; //--> Argument 2
	getfespeech(); /* continue with old pitchbuf */
	/* add periods to the pitch buffer */

	Pitch_offset = saveoffset;
				
	while ( Pitch_offset > Pitch)
		Pitch_offset -= Pitch;

	PitchBlen += Pitch; /* add a Pitch period */				

	//PitchBufStartPtr = PitchBufEndPtr - PitchBlen;
        BuffPtr1 = LastQBuffPtr;
	BuffPtr2 = PitchBuffPtr + HISTORYLEN - PitchBlen - Pitch_overlap;
	BuffPtr3 = PitchBuffPtr + HISTORYLEN - Pitch_overlap;
	Temp1_plc    = Pitch_overlap;

	overlapadd();
				
	BuffPtr1 = speech;  //--> Argument 1
	Temp1_plc   = FRAME_LEN; //--> Argument 2
	getfespeech(); /* get synthesized speech */
	//getfespeech(out, FRAME_LEN);
	BuffPtr1 = TempBuff;
	BuffPtr2 = speech;
	BuffPtr3 = speech;
	Temp1_plc    = Pitch_overlap;
	overlapadd();
	//overlapadd(tmp, out, out, SMM_Pitch_overlap);

	scalespeech();
#endif
	break;

/**************************************************************************
	   	       --->>> End of Second State <<<---
***************************************************************************/			
/***************************************************************************    
	   	      --->> Third  state	 --<<
***************************************************************************/

  case 	G711PLC_STATE3 :
#if 1	        
	BuffPtr1 = speech;  //--> Argument 1
   	Temp1_plc   = FRAME_LEN; //--> Argument 2
   	getfespeech(); /* get synthesized speech */

	//getfespeech(out, FRAME_LEN);
	scalespeech();
#endif
	break;
/***************************************************************************    
	   	      --->> End of Third state	 <<--
***************************************************************************/
/***************************************************************************    
	   	       --->>> Fourth Satate  <<<---
***************************************************************************/
case 	G711PLC_STATE4 :
#if 1
        //--> Fill zeros in SpeechBuffer
	zeros();
#endif
        break;

/***************************************************************************    
	   	      --->> End of Fourth state	 --<<
***************************************************************************/
  default : break;
		
	 } //--> End of Switch Case

#if 1
    	//--> Increment the State of  Erasure
	EraseCnt = EraseCnt + 1;

	/**************************************
       	      CLIP the value of EraseCnt
	**************************************/
	if(EraseCnt >= 11)
  	    EraseCnt = 11;

#endif
		
	/******************************************************************** 
	     update of history buffer and getting speech with 3.75ms delay 
	     takes place here for erased frames.  		
	*********************************************************************/
	savespeech(); 		
}


#endif
