/******************************************************************************
File Name	: ToneGenVar.c
Description    	: This file contains the variable declarations for
		  Tone Generation module
Version Number	: 1.0
*****************************************************************************/

#include "ToneGenCons.h"

#if TONE_GEN

 /**************************************************
   SMM_DM_RAM  ToneGeneration Global Variables 
 **************************************************/

	
Word16 SMM_ToneSampleCtr[MAX_CHAN];
Word16 SMM_PauseSampleCtr[MAX_CHAN];

Word16 SMM_ToneGen_Phase1[MAX_CHAN];
Word16 SMM_ToneGen_Phase2[MAX_CHAN];

Word16 SMM_ToneGen_Scale1[MAX_CHAN];
Word16 SMM_ToneGen_Scale2[MAX_CHAN];
	
Word16 SMM_TonePrevSampleCtr[MAX_CHAN];
Word16 SMM_PausePrevSampleCtr[MAX_CHAN];

	
Word16 SMM_ToneGen_Phasetemp[MAX_CHAN][2];

Word16 SMM_StutterToneCntr[MAX_CHAN] = {0};

Word16 SMM_CallWaitingCntr[MAX_CHAN] = {0};

Word16 SMM_MelodyToneCntr[MAX_CHAN]  = {0};
Word16 SMM_SplDlToneCntr[MAX_CHAN]  = {0};
Word16 SMM_MelodyToneUpDonwFlag[MAX_CHAN] = {0};

Word16 SMM_ToneDuration[MAX_CHAN];


/*******************************************
  ToneGeneration Local Variables
*******************************************/	

Word16 ToneType;
Word16 ToneSampleCtr ;
Word16 PauseSampleCtr;

Word16 ToneGen_Phase1;
Word16 ToneGen_Phase2;

Word16 ToneGen_Scale1;
Word16 ToneGen_Scale2;
	
Word16 ToneRemSampleCtr;
Word16 TonePrevSampleCtr;	
Word16 ToneSampCnt;	
Word16 PauseRemSampleCtr;
Word16 PausePrevSampleCtr;
Word16 PauseSampCnt;
Word16 ToneGen_Phasetemp[2];

/*******************************************
  France Related Variables
*******************************************/
Word16 SMM_SplInfoToneCntr[MAX_CHAN];
Word16 SMM_RocToneCntr[MAX_CHAN];
Word16 SMM_MesgIndToneCntr[MAX_CHAN];
Word16 VOIPDailToneCntr[MAX_CHAN];
Word16 SMM_SplInfoToneUpDownFlag[MAX_CHAN];
Word16 SMM_RocToneUpDownFlag[MAX_CHAN];


/*******************************************
  Korea Related Variables
*******************************************/

Word16 SMM_ToneGen_Phase3[MAX_CHAN];
Word16 SMM_ToneGen_Phase4[MAX_CHAN];
	
Word16 SMM_ToneGen_Scale3[MAX_CHAN];
Word16 SMM_ToneGen_Scale4[MAX_CHAN];

Word16 SMM_ToneGen_Phasetemp1[MAX_CHAN][2];

Word16 SMM_bPha3[MAX_CHAN];
Word16 SMM_bPha4[MAX_CHAN];

Word16 ToneGen_Phase3;
Word16 ToneGen_Phase4;

Word16 ToneGen_Scale3;
Word16 ToneGen_Scale4;

Word16 ToneGen_Phasetemp1[2];
Word16 ToneGen_x1;	//Temporary variables
Word16 ToneGen_x2;


/*******************************************
  Japan Related Variables
*******************************************/

Word16 SMM_WaitingToneCntr[MAX_CHAN] = {0};
Word16 SMM_PosIndToneCntr[MAX_CHAN] = {0};

Word16 Sample1;
Word16 Sample2;

Word16 Temp1;
Word16 CurChanNum;
Word16 ToneGenState;


/*******************************************
  Tone Generation State Variables
*******************************************/

Word16 SMM_ToneGenState[MAX_CHAN];
Word16 SMM_ToneGenEna[MAX_CHAN];
Word16 SMM_ToneType[MAX_CHAN];

///////For Generic function

Word16 SMM_ToneInit_flag[MAX_CHAN];
Word16 SMM_CadCnt[MAX_CHAN];
Word16 SMM_CadCntr[MAX_CHAN];
Word16 SMM_bUseGeneric[MAX_CHAN]={0};
Word16 SMM_CadPlayStopFlag[MAX_CHAN];
Word16 SMM_ToneDurationCntr[MAX_CHAN];


// FOR FAR END TONE

#ifdef FAR_END_TONE_SUPPORT
Word16 SMM_FarEndToneFlag[MAX_CHAN];
Word16 SMM_TonePayLoadBuff[MAX_CHAN];
#endif



#endif


