/****************************************************************************
 *
 * /home/bat/bat/fast3202_4_0_21_3_3_1/rg/vendor/adi/ad6843/common/kernel/epld.h
 * 
 * Copyright (C) Jungo LTD 2004
 * 
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Developed by Jungo LTD.
 * Residential Gateway Software Division
 * www.jungo.com
 * info@jungo.com
 */

#ifndef _EPLD_H_
#define _EPLD_H_

typedef enum {
    /* Do NOT change number assignments! */
    EPLD_REG0 = 0,
    EPLD_REG1 = 1,
    EPLD_REG2 = 2,
    EPLD_REG3 = 3
} epld_reg_num_t;

/* Register 0 control bits */
#define EPLD_LED_LAN_TRAF 0x01
#define EPLD_LED_PHONE 0x02
#define EPLD_LED_WAN 0x04
#define EPLD_LED_WIRELESS 0x08
#define EPLD_LUMIN0 0x10
#define EPLD_LUMIN1 0x20
#define EPLD_LUMIN2 0x40
#define EPLD_LUMIN3 0x80
#define EPLD_LUMINUS_ALL EPLD_LUMIN0 | EPLD_LUMIN1 | EPLD_LUMIN2 | EPLD_LUMIN3

/* Register 1 control bits */
#define EPLD_LED_FAIL 0x01
#define EPLD_USBEN 0x02
#define EPLD_RST_USBH_N 0x04
#define EPLD_FXS_EXT_LINE_N 0x08

/* Register 2 status bits */
#define EPLD_CB_DETECT 0x01
#define EPLD_INT_USBH_N 0x02
#define EPLD_RST_CONFIG_N 0x04
#define EPLD_W_LUMIN_N 0x08

/* Register 3 control/status bits */
#define EPLD_RELANCE_WDOG 0x01
#define EPLD_SPI_CS_FXO_N 0x02
#define EPLD_USBPOWDET 0x04
#define EPLD_WIRELESS_ASSOC 0x08

/* set (bitwise or) given flags on the given epld register */
void epld_reg_flags_set(epld_reg_num_t reg, unsigned short flags);
/* reset (bitwise negate,and) given flags on the epld register */
void epld_reg_flags_reset(epld_reg_num_t reg, unsigned short flags);
/* toggle (bitwise xor) given flags on the epld register */
void epld_reg_flags_toggle(epld_reg_num_t reg, unsigned short flags);
/* write flags to the epld registers masked with mask */
void epld_reg_flags_mask_write(epld_reg_num_t reg, unsigned short flags,
    unsigned short mask);
/* return content of given epld register */
unsigned short epld_reg_read(epld_reg_num_t reg);
/* initialize epld registers */
void epld_reg_init(void);

#endif
