#ifndef _msg_h
#define _msg_h



//////////////////////////////T.38 //////////////////////////////////


//---------------------------------------------------------------------------
//The following defines the ID's of messages to the data pump
//---------------------------------------------------------------------------
#define mDATATODP           0	// Indicates Data to be sent to DP
#define mDP_MOD_DATA		0
#define mORIGINATE          1	// Indicates Originate Mode or Transmit Mode
#define mDP_ORIGINATE		1
#define mANSWER             2	// Indicates Answer Mode or Receive Mode
#define mDP_ANSWER			2
#define mLOOPBACK           3	// Indicates the Digital Loop Back Mode
#define mDIALNUMBER			4   //Dial the remote number 
#define mTONEDIAL			4
#define mDP_TONEDIAL		4
#define	mDATAMODESELECT     5	// Indicates DataMode HDLC or NON_HDLC
#define mDP_DATAMODE_SELECT	5
#define	mMODESELECT         6	//
#define mRATESELECT         7	// Indicates the Rate at which Data will be Transferred or Received
#define mDP_RATE_SELECT		7
#define mHANGUP             8	// Indicates the End of the Session
#define mDP_HANGUP			8
#define mSHUTDOWN           9	
#define	mCLPRGSELECT        10	// Indicates the Call Progress Info
#define	mSTARTFAXTX         11	// Indicates the DP to Transfer the DATA
#define mDP_START_FAXTX		11
#define	mSTARTFAXRX         12	// Indicates the DP to Receive the DATA
#define	mDP_START_FAXRX		12
#define mENDFAXTXRX         13	// Indicates End of Data Reception
#define mDP_ENDFAX_TXRX		13
#define mDETECTDIALTONE		14	// Indicates the Detection of Dial Tone
#define mDIALDURATION		15	// Indicates the Dial Tone Duration
#define mSETDTMFLEN			15	//Configure the DTMF duration
#define mDP_DIALDURATION	15
#define mCONFIGTXLVL		16  //Program the transmit level in dBm units
#define mSETTXLEVEL			16	// Indicates the Transmit Level of the Signal
#define mDP_SET_TXLEVEL		16
#define mT30IPMSG			17
#define mHDLCFRMEND			18	// Indicates the End of the Frame in ECMode
#define mFCSOK				19
#define mDP_FCSOK			19
#define mFCSBAD				20
#define mDP_FCSBAD			20



//---------------------------------------------------------------------------
//The following defines the ID's of Response messages from the data pump
//---------------------------------------------------------------------------
#define mDATATOHOST			0
#define mDP_DEMOD_DATA		0
#define mCONNECT			1
#define mDP_CONNECT			1
#define mNOCARRIER			2
#define mDP_NO_CARRIER		2
#define mDPREADY			3
#define mMODEMREADY			3
#define mCRCOK				4
#define mDP_DEMOD_CRCOK		4
#define mCRCERROR			5
#define mDP_DEMOD_CRCERROR	5
#define mFRAMEACK			6
#define mDP_FRAME_ACK		6
#define mXON				7
#define mDP_XON				7
#define mXOFF				8
#define mDP_XOFF			8
#define mFAXTXRXEND			9
#define mDP_FAX_TXRX_END	9
#define mDETECTFLAG			10
#define mDP_DEMOD_DET_FLAG	10
#define mGOTDIALTONE		11
#define mGOTBUSYTONE		12
#define mGOTRINGBACK		13
#define mDIALEND			14	// Indicates the End of Dial Tone End
#define mTONEDIALEND		14
#define mDP_DIALEND			14
#define mREMOTERETRAIN		15
#define mLOCALRETRAIN		16	// Indicates the Detection of Flags
#define mDET7E				17
#define mBERINFO			18	// Indicates the Bit Error Info
#define mENDOFANSTONE		19
#define mSTARTRXEPT			20
#define mSTARTRXTRN			21
#define mDP_DEMOD_DET_TRN	21
#define mENDTXEPT			22  // DP completed EPT signal transmission


//Messages to T.30
#define mLOCIDFRAME			64	// Indicates the Local Identification 
#define mNSFFRMDATA			65
#define mPWDFRMDATA			66
#define mENDPAGETX			67	// Indicates the End of transmission of the current page.
#define mECMODECONFIG		68	// Indicates the ECMode Configurations
#define mSUBFRMDATA			69
#define mSEPFRMDATA			70
#define mINDICATEPAGECONFIG	71	// Indicates the Default Page Configurations
#define mSETSFCAPABILITY	72	// Indicates the SoftFax Capabilities
#define mSETADLCAPABILITY	73	// Indicates the Additional Capabilities of the SoftFax
#define mENDPAGERX			74	// Indicates the End of the Page Reception
#define	mDISCONNECT			75	// Indicates the Disconnection of the session
#define	mMEMADDRESS			76
#define mOPENT30			77	// Indicates the T30 Open Channel
#define mDATATOT30FROMDP	78	// Indicates Data from DP
#define mGOTCRCOK			79	// Indicates the Received frame correct
#define mGOTCRCBAD			80	// Indicates the Received frame in Error
#define mDPCONNECT			81	// Indicates DP Ready to Transmit or Receive data
#define mNOCARFROMDP		82	// Indicates Absence of Remote Carrier
#define mGOTFRMACK			83	// Indicates the Acknowledgement for frame sent
#define mGOTTXRXEND			84	//	
#define mGOTDET7E			85	// Indicates the DP detected the flags
#define mHOSTDATATX			86	// Indicates the Data sent by Host in Non_ECMode only
#define mHOSTECMDATATX		87	// Indicates the Data sent by Host in ECMODE
#define mT30HANGUP			88	// Indicates the End of T30 session


//Message from T.30
#define mT30MSGTODP			64	// Indicates T.30 Message To DP
#define	mFAXSESSIONENDS		65	// Indicates the End of T.30 fax session.
#define mREMPAGECONFIG		66	// Indicates the Remote Page Configurations
#define mREMCAPABILITY		67	// Indicates the Remote Capabilities
#define mREMADLCAPABILITY	68	// Indicates the Remote Additional Capabilities(SEP,SUB,PWD Select)
#define mRXPOSTMSG			69	// Indicates the Received Post Message Command(PPS_MPS,MPS)
#define mRXOPTFRAME			70	// Indicates the Received Optional Frames(CSI,TSI,NSF,)
#define mPAGETXENDS			71	// Indicates the End of the Remote Page Transmission
#define	mRXECMPARTPAGE		72	// Indicates the Remote ECM Partial Page
#define mREMECMCONFIG		73	// Indicates the Remote ECM Configurations(EcmFrmSize)
#define mT30STOPDATA		74	// Indicates the End of Transmission of Page Data
#define mRXPAGEERRORINFO	75	// Indicates the Error Page Info
#define mHOSTSTARTDATA		76	// Indicates the Host Start send Data
#define mHOSTDATARX			77	// Indicates the Host To Receive the Data
#define mHOSTSTARTECMDATA	78	// Indicates the Host start send data in ECMODE



//---------------------------------------------------------------------------
//The following defines the ID's of messages sent by Host to the T.38 layer
//---------------------------------------------------------------------------
#define mDATAFROMDP     64
#define mDPDETRXTRN     65

//---------------------------------------------------------------------------
//The following defines the ID's of Response messages from the T.38 layer
//---------------------------------------------------------------------------
#define mT38MSGTODP			64
#define mT38VALIDOPPKT		65
#define mT38_VALID_OPPKT	65
#define mRXCNGPKT			66
#define mT38_RX_CNGPKT		66
#define mT38_ENDOFSESSION       67 //Dhruva 080604



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

///////////////////  T.30 /////////////////////////////////////////

/* Error Codes */
#define NORMAL_DISCONNECTION		0
#define DATA_BUFFER_OVERFLOW		5
#define LOST_REMOTE_CARRIER			12



//mPAGETXENDS

#define PAGETXOK		0
#define PAGETXERROR		1
#define CONTINUEPAGETX		2
#define REMOTEFLOWCONTROL	3
#define PARTIALPAGERETX		4


//mENDPAGERX

#define RECEIVERREADY		1
#define RECEIVERNOTREADY	2
#define RQSTTORETRANSMIT	3



#define PAGETOFOLLOW		2

#define LASTPAGESENT		4

#define CHANGEMODE		1

#define PARTIALPAGE		0

#define ISRECEIVERREADY		6

/*minimum scan time supported*/

#define T385LFOR40MS		4
#define T385LFOR20MS		3
#define T385LFOR10MS		2
#define T385LFOR5MS			1
#define T385LFOR0MS			0

/*printer options when the session is in answer mode used along with

scan time option*/

#define T77HALFOFT385           8
#define T154HALFOFT77		16



/*vertical resolution selection*/

#define R8154LFOR1MM 			0x1 	//metric
#define PEL300X300FOR25MM 		0x2     //inch
#define R877LFOR1MM 			0x30    //metric
#define R838LFOR1MM				0x00	//metric default
#define R8200X200FOR25MM		0x28    //inch
#define R16154LFOR1MM 			0x14     // metric
#define R16400X400FOR25MM 		0xc     //inch

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#endif
