/*======================================================================
 *
 * Copyright : (c) 2003 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 *======================================================================
 */

/*======================================================================
 * File Name   :  pstn.h
 * Description :
 * CVS ID   :
 *======================================================================
 */

/*======================================================================
 * History
 *
 * Date         Author     Comment
 * Juin 2004    Epi        Initial version
 *======================================================================
 */
#define DEBUG_PSTN

#define Pstn_TaskPriority  30
#define Pstn_TaskStackSize 8192

#define Pstn_QueueMaxMsgEntry 64 /* QueueSize: 64 msg * 8 octets = 512 octets */
#define Pstn_QueueMaxMsgLength   8

/* InitSoft */
extern void f_PstnInitSoft (void);

/* MainTask */
extern void f_PstnTask (void);

/* commande de la trace */
extern void    f_GestionPstn_OnOffTrace   (UINT8 OnOff);
extern void    f_GestionPstn_Clip         (UINT8 OnOff);
extern void    f_GestionPstn_InfoDebug    (INT16 iDblkId);
extern void    f_GestionPstn_InfoPstn     (INT16 iDblkId);
extern void    f_GestionPstn_Icall        (UINT8 OnOff);
extern void    f_GestionClass_LocalCode   (UCHAR LocalNumber[]);
extern void    f_GestionPstn_Test         (UCHAR CallNumber[]);
extern void    f_GestionClass_List        (INT16 iDblkId);
extern INT16   f_GestionClass_Set         (BOOL IsPrefixChanged, UCHAR Prefix[],
                                           BOOL IsDelNumberChanged, CHAR DelNumber,
                                           BOOL IsAddDigitsChanged, UCHAR AddDigits[],
                                           BOOL IsOutChanged, CallType Out,
                                           BOOL IsNbLengthChanged, UCHAR NbLength);
extern INT16   f_GestionClass_SetDefault  (BOOL IsDelNumberChanged, CHAR DelNumber,
                                           BOOL IsAddDigitsChanged, UCHAR AddDigits[],
                                           BOOL IsOutChanged, CallType Out,
                                           BOOL IsNbLengthChanged, UCHAR NbLength);
extern void    f_GestionClass_Clear       (BOOL all, UCHAR Prefix[]);
extern void    f_GestionClass_ClearDefault(void);
extern void    f_GestionClass_Default     (UINT16 IdCountry);

extern void convDialStr2Digits (unsigned char DialStr, unsigned char *Digits);

/* fonction trace */
typedef enum
{
   e_Receive_Event,
   e_End_Event,
   e_Pstn_State,
   e_Pstn_LineState,
   e_Pstn_CnxState
} Pstn_PrintTraceType;

extern void f_PstnPrint(Pstn_PrintTraceType type, int info, int info1, int info2);

typedef enum
{
   e_pstn_fxs = 1,
   e_pstn_fx0 = 2
} Pstn_Port;

typedef enum
{
   e_pstn_StateLineFree    = 1,
   e_pstn_StateLineRinging = 2,
   e_pstn_StateLineBusy    = 3
} Pstn_lineState;

typedef enum
{
   e_pstn_DialTone = 1,
   e_pstn_BusyTone = 2,
   e_pstn_RingBackTone = 3
} Pstn_Tone;

typedef struct CtxPstn
{
    UCHAR   ucPortNo;
    UCHAR   DialStr[LGMAX_DIAL];
    Pstn_Tone ToneDetect;
} CtxPstn;

typedef enum {
   // appel sortant
   e_pstnEvtInitCall,
   e_pstnEvtDetectTone,
   e_pstnEvtDigitSend,
   e_pstnEvtOnHook,

   // appel entrant
   e_pstnEvtLineFree,
   e_pstnEvtLineRing1Beg,
   e_pstnEvtLineRing1End,
   e_pstnEvtLineRing2Beg,
   e_pstnEvtLineRingBeg,
   e_pstnEvtLineRingEnd,
   e_pstnEvtLineOffHook,
   e_pstnEvtLineInvert,
   e_pstnEvtLineInvertEndNum,			// pour Detection DTMF sur CLIP Q23 (non util)
   e_pstnEvtLineInvertEndNumFalse,
   e_pstnEvtFlashHook,

   e_pstnEvtLineBusy,
   e_pstnEvtLineInvertBusy,
   e_pstnEvtLineOut,
} pstn_evt_type;


typedef enum {
   InitCall,
   DetectTone,
   DigitSend,
   OnHook,
   LineOffHook,
   FlashHook
} evt_type;

typedef enum
{
   e_pstnStateFree,

   // appel sortant
   e_pstnStateOffHook,
   e_pstnStateDialing,
   e_pstnStateConnected,

   // appel entrant
   e_pstnStateLib,
   e_pstnStateRing1Beg,
   e_pstnStateRing1End,
   e_pstnStateRing2Beg,
   e_pstnStateRingBeg,
   e_pstnStateRingEnd,

   e_pstnStateBusy,
   e_pstnStateOut,
   e_pstnStateLineInvert,
   e_pstnStateFreeInCall,

   e_pstnStateError
} Pstn_State;
