#ifndef _IPVOICE_VOICEOPT_H_
#define _IPVOICE_VOICEOPT_H_


#define DSP_ENC_SPEECH_PKT_SIZE_FST     0
#define DSP_ENC_SPEECH_PKT_SIZE_LEN     7
#define DSP_ENC_AGC_EN_BIT              7
#define DSP_ENC_DTMF_EN_BIT             8

#define DSP_ENC_SPORT_TYPE_FST          9
#define DSP_ENC_SPORT_TYPE_LEN          2
#define DSP_ENCODER_TYPE_FST           11
#define DSP_ENCODER_TYPE_LEN            4
#define DSP_ENCODER_ACTIVE_BIT         15

#define DSP_ENC_G168_EC_EN_BIT          8
#define DSP_ENC_VAD_PACKET_SIZE_FST     9
#define DSP_ENC_VAD_PACKET_SIZE_LEN     5
#define DSP_ENC_VAD_TYPE_FST           14
#define DSP_ENC_VAD_TYPE_LEN            2

#define DSP_ENC_G168_TAIL_LENGTH_FST    0 
#define DSP_ENC_G168_TAIL_LENGTH_LEN    9 

#define DSP_ENC_DTMF_REJ_EN_BIT      2
#define ENCODER_DTMF_REJ_ENABLE      1
#define ENCODER_DTMF_REJ_DISABLE     0


#define DSP_DEC_SPEECH_PKT_SIZE_FST     0
#define DSP_DEC_SPEECH_PKT_SIZE_LEN     7
#define DSP_DEC_TONE_GEN_EN_BIT         7
#define DSP_DEC_PLC_EN_BIT              8
#define DSP_DEC_SPORT_TYPE_FST          9
#define DSP_DEC_SPORT_TYPE_LEN          2
#define DSP_DECODER_TYPE_FST           11
#define DSP_DECODER_TYPE_LEN            4
#define DSP_DECODER_ACTIVE_BIT         15

#define DSP_DEC_VAD_PACKET_SIZE_FST     9
#define DSP_DEC_VAD_PACKET_SIZE_LEN     5
#define DSP_DEC_VAD_CNG_FST            14
#define DSP_DEC_VAD_CNG_LEN             2


#define DSP_DEC_VAR_GAIN_CNTL_FST     0
#define DSP_DEC_VAR_GAIN_CNTL_LEN     8


#define SPEECH_PKT_SIZE_G711    44
#define SPEECH_PKT_SIZE_G726    44
    
#define ENCODER_AGC_ENABLE       1
#define ENCODER_AGC_DISABLE      0

#define ENCODER_DTMF_ENABLE      1
#define ENCODER_DTMF_DISABLE     0

#define ENCODER_DTMF_REJ_ENABLE      1   // rfc 2833  or  outband  dtmf
#define ENCODER_DTMF_REJ_DISABLE     0

#define SPORT_A_TYPE             0
#define SPORT_MU_TYPE            1 
#define SPORT_LINEAR_TYPE        2

#define G711_A_LAW               0
#define G711_MU_LAW              1
#define G726_16_KPBS             2
#define G726_24_KPBS             3
#define G726_32_KPBS             4
#define G726_40_KPBS             5 

#define ENCODER_ACTIVE           1
#define ENCODER_INACTIVE         0
    
#define G168_EC_ACTIVE           1
#define G168_EC_INACTIVE         0
    
#define VAD_0_PKT_SIZE           0
#define VAD_1_PKT_SIZE           1
#define VAD_2_PKT_SIZE           11

#define VAD_DISABLE              0
#define VAD_1_TYPE               1
#define VAD_2_TYPE               2

#define VAR_GAIN_CNTL            0x0F

    
#define G168_TAIL_LEN_0         0
#define G168_TAIL_LEN_2_5       20
#define G168_TAIL_LEN_5         40
#define G168_TAIL_LEN_7_5       60
#define G168_TAIL_LEN_10        80
#define G168_TAIL_LEN_12_5      100
#define G168_TAIL_LEN_15        120
#define G168_TAIL_LEN_17_5      140
#define G168_TAIL_LEN_20        160
#define G168_TAIL_LEN_22_5      180
#define G168_TAIL_LEN_25        200
#define G168_TAIL_LEN_27_5      220
#define G168_TAIL_LEN_30        240
#define G168_TAIL_LEN_32_5      260

#define TONE_GEN_ENABLE         1 
#define TONE_GEN_DISABLE        0
    
#define PLC_ENABLE              1 
#define PLC_DISABLE             0
    
#define DECODER_ACTIVE          1
#define DECODER_INACTIVE        0

#define DECODER_TONE_FILTER_BIT			6
#define DECODER_TONE_FILTER_ENABLED		1
#define DECODER_TONE_FILTER_DISABLED	0


#endif  /* _VOICEOPT_H_ */

