/* ============================================================================
 *
 * Copyright (C) 2001 Analog Devices Inc. All rights reserved
 *
 * The information and source code contained herein is the exclusive property
 * of Analog Devices and may not be disclosed, examined or reproduced in whole
 * or in part without the explicit written authorization from Analog Devices.
 *
 * ============================================================================
 */


#include<oswrapper.h>
#include "legerityrw.h"
#define printf PRINT

#define DEBUG_READ 0
extern slicHandlers_t slicHandlers;
static unsigned char StValue1,StValue2;

unsigned char z_coeff[]={
                             0x80,
                                 0xa4,
                                 0x00,
                                 0x36,
                                 0xfc,
                                 0x7b,
                                 0xfe,
                                 0xe7,
                                 0x00,
                                 0xbb,
                                 0x01,
                                 0x73,
                                 0x00,
                                 0x60
                           };
//rcoeff 14

//Alaw
unsigned char r_coeff[]={
                                  0x85,
                                    0xbb,
                                    0x00,
                                    0x0b,
                                    0xff,
                                    0xe8,
                                    0x00,
                                    0x7f,
                                    0x00,
                                    0xd5,
                                    0xfe,
                                    0xcc,
                                    0x40,
                                    0xbb
                               };


         //Alaw
unsigned char x_coeff[]={
                                        0x00,
                                        0x00,
                                        0xfd,
                                        0xb8,
                                        0x02,
                                        0xf6,
                                        0x00,
                                        0x0c,
                                        0xfc,
                                        0xbf,
                                        0x00,
                                        0x4f,
                                        0x40,
                                        0x6b
                          };



           //Alaw
unsigned char grc_coeff[]={
                            0x4e,
                            0x01
                          };




unsigned char gxc_filter[]={
                             0xfe,
                             0x83,
                           };



 //b_filter coeff1 14

unsigned char b_filter_coeff1[]=
                                {
                                     0xff,
                                     0xb6,
                                     0xff,
                                     0x95,
                                     0xff,
                                     0xd4,
                                     0x01,
                                     0x88,
                                     0x13,
                                     0xb3,
                                     0x28,
                                     0xdb,
                                     0x11,
                                     0xf3,
                                 };


//Alaw

unsigned char b_filter_coeff2[]=
                                       {
                                            0xfd,
                                            0xdf,
                                            0x81,
                                            0x48,
                                            0xff,
                                            0xbc,
                                            0xff,
                                            0xbc,
                                            0xff,
                                            0xbb,
                                            0xff,
                                            0xba,
                                            0xff,
                                            0xba

                                      };



unsigned char err_level_threshold[]={ 0x04};
unsigned char echo_path_gain[]={0x04};
unsigned char adaptive_bfilter_coeff[]=
                                  {
                                         0x02,
                                         0x20,
                                         0x1c,
                                         0x00
                };

         //Alaw
unsigned char loop_supv_params[]={
                                                     0x0d,
                                                     0x80,
                                                     0x00,
                                                     0x7f,
                                                     0x0f,
                                                     0x00,
                                                     0x7f,
                                                     0x7f,
                                                     0x07,
                                                     0x0b,
                                                     0x7f
                };

            //Ulaw
unsigned char analog_gain = {0x02};
unsigned char signal_generatorA[]={
                                                   0x00,
                                                   0x00,
                                                   0x01,
                                                   0x01,
                                                   0x5b,
                                                   0x4c,
                                                   0x39,
                                                   0x9a,
                                                   0x00,
                                                   0x00
                };




void codecPcmInterface_78d11(unsigned char ucCodecType)
{
  DEBUG(PRINT("Codec Type => %d\n",ucCodecType),DEBUG_INFO);
  switch(ucCodecType)
  {
   case A_LAW:
    slicHandlers.ucTimeSlot0 = 1;
    slicHandlers.ucTimeSlot1 = 2;
    slicHandlers.ucPcmMode = 0x00; //A-law
    slicHandlers.ucClock = 0x93;  //  ---2.048MHz
    break;
   case MU_LAW:
    slicHandlers.ucTimeSlot0 = 1;
    slicHandlers.ucTimeSlot1 = 2;
    slicHandlers.ucPcmMode = 0x40; //Mu-Law
    slicHandlers.ucClock = 0x93;  //  ---2.048MHz
    break;
   case LINEAR:
    slicHandlers.ucTimeSlot0 = 3;
    slicHandlers.ucTimeSlot1 = 5;
    slicHandlers.ucPcmMode = 0x01; //Linear
    slicHandlers.ucClock = 0x97;  //  ---4.096MHz
    break;
   default:
    slicHandlers.ucTimeSlot0 = 3;
    slicHandlers.ucTimeSlot1 = 5;
    slicHandlers.ucPcmMode = 0x01; //Linear
    slicHandlers.ucClock = 0x97;  //---4.096MHz
   break;
  }
 DEBUG(PRINT("Sport Codec:%d\r\n",ucCodecType), DEBUG_INFO);
}

/*======================================================================
 * Function Name        : codecChanWriteEnable
 * Description          : Enable the channel programming for the given
 *                        channel
 *======================================================================
 */

static void codecChanWriteEnable(int codecNo, int chNo)
{
 if (chNo ==0)
   write2codec2word(codecNo, 0x4a, 0x1);
 else
   write2codec2word(codecNo, 0x4a, 0x2);
}


/*======================================================================
 * Function Name        : codecChanWriteDisable
 * Description          : Disable the channel programming for the given channel
 *======================================================================
 */

static void codecChanReadDisable(int codecNo,int chNo)
{
  write2codec2word(codecNo, 0x4a, 0x00);
}

/*======================================================================
 * Function Name        : codecChanWriteDisable
 * Description          : Disable the channel programming for the given channel
 *======================================================================
 */

static void codecChanWriteDisable(int codecNo,int chNo)
{
  write2codec2word(codecNo, 0x4a, 0x0);
}

static void codecChanReadEnable(int codecNo, int chNo)
{
  if(chNo==0)
    write2codec2word(codecNo, 0x4a, 0x1);
  else
    write2codec2word(codecNo, 0x4a, 0x2);
}


/*======================================================================
 * Function Name        : codecChanWriteValue
 * Description          : write the given data at given address for a
 *                        given channel for the given codec.
 *======================================================================
 */
void codecChanWriteValue(int codecNo, int chNo,
                           unsigned char addr, unsigned char data)
{
  // enable the channel programming capability
  codecChanWriteEnable(codecNo, chNo);
  write2codec2word(codecNo, addr, data);
}


/*======================================================================
 * Function Name        : codecReadValue
 * Description          : read the data from given address
 *======================================================================
 */
unsigned char codecReadValue(int codecNo, unsigned char addr)
{
  unsigned char value;
  value = read2codec2word(codecNo, addr);
  return value;
}


/*======================================================================
 * Function Name        : codecRingToneSetting
 * Description          : generate the ringing tone for the given slic
 *======================================================================
 */
static void codecRingToneSetting(int codecNo, int chNo)
{
  codecChanReadEnable(codecNo, chNo);
  StValue1=codecReadValue( codecNo, 0x75) ;
  StValue2=codecReadValue( codecNo, 0xcb) ;
  codecChanReadDisable(codecNo, chNo);
  codecChanWriteEnable( codecNo, chNo);
  codecChanWriteValue(codecNo, chNo, 0x74,  0x10);
  codecChanWriteValue(codecNo, chNo, 0xca,  0x00);
  codecChanWriteDisable( codecNo, chNo);
}

/*======================================================================
 * Function Name        : slicModeSetting
 * Description          : setting the slic mode
 *======================================================================
 */
void slicModeSetting_78d11(int codecNo, int chNo, int mode)
{
  unsigned char data,dummy;
  /* enable the channel programming capability */
  codecChanWriteEnable(codecNo, chNo);
  switch(mode)
  {
    case SLIC_STANDBY:
      codecChanReadEnable(codecNo,chNo);
      dummy=codecReadValue( codecNo, 0x57) ;
      codecChanWriteEnable(codecNo,chNo);
      data=0x30 |dummy;
      codecChanWriteValue(codecNo, chNo, 0x56,  data);
      codecChanWriteDisable(codecNo,chNo);
      break;
    case SLIC_ACTIVE:
      codecChanReadEnable(codecNo,chNo);
      dummy=codecReadValue( codecNo, 0x57) ;
      codecChanWriteEnable(codecNo,chNo);
      codecChanWriteValue(codecNo, chNo, 0x74,  0x0);
      codecChanWriteValue(codecNo, chNo, 0xca,  0x2);
      codecChanWriteValue(codecNo, chNo, 0x56,  0x32);
      codecChanWriteDisable(codecNo,chNo);
      break;
    case SLIC_RING:
      codecRingToneSetting(codecNo, chNo);
      codecChanWriteEnable(codecNo,chNo);
      codecChanWriteValue(codecNo, chNo, 0x56,  0x37);
      break;
    case SLIC_RING_LOWBSEL:
        #if 0

        codecRingToneSetting(codecNo, chNo);
        addr = 0x8a;
        data = 0x40;
        //codecChanWriteValue(codecNo, chNo, addr, data);               // Set the SLIC in RING Mode
        #endif
        break;
    case SLIC_RINGOFF:
      codecChanWriteEnable( codecNo, chNo);
      codecChanWriteValue(codecNo, chNo, 0x74,  StValue1);
      codecChanWriteValue(codecNo, chNo, 0xca,  StValue2);
      codecChanWriteEnable(codecNo,chNo);
      codecChanWriteValue(codecNo, chNo, 0x56,  0x32);
      break;
    case SLIC_LOOPBACK:
      codecChanReadEnable(codecNo,chNo);
      dummy=codecReadValue( codecNo, 0x57) ;
      codecChanWriteEnable(codecNo,chNo);
      data=dummy | 0x32;
      codecChanWriteValue(codecNo, chNo, 0x56,  data);
      break;
    default:
      break;
  }
  /* diable the channel programming capability */
  codecChanWriteDisable(codecNo,chNo);
}
/*======================================================================
 * Function Name        : codecReadStatus
 * Description          : read the codec status register and return the value
 *======================================================================
 */

unsigned short codecReadStatus_78d11 (int codecNo)
{
     char addr, dummy,data,tempval1,tempval2;

        addr=0x4b;
        data=0x1;
        write2codec2word(codecNo, addr, data);

        addr=0x21;
        dummy = read2codec2word(codecNo, addr);
//printk("Dummy => %x\n",dummy);
        addr=0x4b;
        data=0x0;
        write2codec2word(codecNo, addr, data);
#if 1
        dummy= dummy & 0xa;
        tempval1=dummy>>1;
        tempval2=tempval1>>1;
        tempval1= tempval1 & 0x1;
        tempval2=tempval2  &0x2;
        dummy= tempval2 | tempval1;
 #endif

        return dummy;
}

/*============================================================================
  Function to initialize Codec .
 ============================================================================= */

void legerity78d11_init(int codecNo)
{
  int j;
  UCHAR pcmMode = confGetPCMMode(0);
  DEBUG(PRINT("Initializing Legerity78d11 Codec No => %d\n",codecNo),DEBUG_INFO);
  pcmMode = SPORT_CODEC;
  codecPcmInterface_78d11(pcmMode);
  /* Hardware reset */
  write2codec1word(codecNo, 0x04);
  mdelay(20);
  /* Clock */
  write2codec2word(codecNo,0x46,slicHandlers.ucClock);    
  osLockInterrupts();
  pollOnReg(codecNo,0x3D,0,4);
  osUnlockInterrupts();
  printk("Revision Code  \n\r");
  read2codec2wordprintf(codecNo, 0x73);

  for(j=0;j<2;j++)
  {
    codecChanWriteEnable(codecNo, j);

    // Z-Filter Coefficients
    write2codecArray(codecNo, 0x84, z_coeff, 14);

    // R-Filter coefficients
    write2codecArray(codecNo, 0x8a, r_coeff, 14);
    // X-Filter coefficients
    write2codecArray(codecNo, 0x88, x_coeff, 14);
    // GR
    write2codecArray(codecNo, 0x82, grc_coeff, 2);
    // GX
    write2codecArray(codecNo, 0x80, gxc_filter, 2);
    // B-Filter1 Coefficients
    write2codecArray(codecNo, 0x86, b_filter_coeff1, 14);
    // B-Filter2 Coefficients
    write2codecArray(codecNo, 0x96, b_filter_coeff2, 14);
    // Error Threshold Settings
    write2codec2word(codecNo, 0x8e, 0x04);
    //Echo path gain
    write2codec2word(codecNo, 0x8c, 0x04);
    //Adaptive Filter  initialization
    write2codecArray(codecNo, 0x90, adaptive_bfilter_coeff, 4);
    //Loop supervison initialization
    write2codecArray(codecNo, 0xc2, loop_supv_params, 11);
    //Analog gain settings
    write2codec2word(codecNo, 0xca, analog_gain);
    // Channel Configuration Register Tx/Rx/HPC/Rxpcm Enabled CCR1
    write2codec2word(codecNo, 0x62, 0x00);
    //configure adpative filter
    write2codec2word(codecNo, 0x60, slicHandlers.ucPcmMode);
    // Transmit Time Slot
    if(j==0)
      write2codec2word(codecNo, 0x40, slicHandlers.ucTimeSlot0);
    else
      write2codec2word(codecNo, 0x40, slicHandlers.ucTimeSlot1);
    //Receive Time slot register
    if(j==0)
      write2codec2word(codecNo, 0x42, slicHandlers.ucTimeSlot0);
    else
      write2codec2word(codecNo, 0x42, slicHandlers.ucTimeSlot1);
    // Clock skew  // Only once
    write2codec2word(codecNo, 0x44, 0x3f);
    //Signal generator  initialization
    write2codecArray(codecNo, 0xd2, signal_generatorA, 10);
    //Activate Codec
    write2codec1word(codecNo, 0x0e);
    //VoSlac register
    write2codec2word(codecNo, 0x56, 0x30);
    //Channel configuration register -8
    write2codec2word(codecNo, 0x74, 0x80);
    //Activate Slic calibration command
    write2codec1word(codecNo, 0x7c);
    mdelay(30);
    //Channel configuration register -8
    write2codec2word(codecNo, 0x74, 0x00);
    //VoSlac
    write2codec2word(codecNo, 0x56, 0x32);
    codecChanWriteDisable(codecNo, j);
  }

#if DEBUG_READ
  codecReadPrintfValues(codecNo);
#endif

  DEBUG(PRINT("Legirity (78d11) Codec (%d)  Initialized \n",codecNo),DEBUG_INFO);
  printk("CheckSum::\n\r");
  read2codec2wordprintf(codecNo, 0x33);
}




#if DEBUG_READ
void codecReadPrintfValues(int codecNo)
{
int j;
unsigned char addr, data;


        addr = 0x47;
        data = read2codec2wordprintf(codecNo, addr);
        for(j=0; j<2; j++)
        {
                codecChanReadEnable(codecNo, j);

                // Z-Filter Coefficients
                printf("\n\rz-Filter Coefficients\n\r");
                addr=0x85;
                read2codecArrayPrintf(codecNo, addr, 14);

                // R-Filter coefficients
                printf("\n\rR-Filter Coefficients\n\r");
                addr=0x8B;
                read2codecArrayPrintf(codecNo, addr, 14);

                // X-Filter coefficients
                printf("\n\rX-Filter Coefficients\n\r");
                addr=0x89;
                read2codecArrayPrintf(codecNo, addr,  14);

                // GR
                printf("\n\rGR-Filter Coefficients\n\r");
                addr=0x83;
                read2codecArrayPrintf(codecNo, addr,  2);

                // GX
                printf("\n\rGX-Filter Coefficients\n\r");
                addr=0x81;
                read2codecArrayPrintf(codecNo, addr,  2);

                // B-Filter1 Coefficients
                printf("\n\rB-Filter1 Coefficients\n\r");
                addr=0x87;
                read2codecArrayPrintf(codecNo, addr,  14);

                // B-Filter2 Coefficients
                printf("\n\rB-Filter2 Coefficients\n\r");
                addr=0x97;
                read2codecArrayPrintf(codecNo, addr,  14);

                // Error Threshold Settings
                printf("\n\rErrorThreshold Coefficients\n\r");
                addr = 0x8f;
                read2codecArrayPrintf(codecNo, addr, 1);
                //Echo path gain
                printf("\n\rEcho Path Gain Coefficients\n\r");
                addr = 0x8d;
                read2codecArrayPrintf(codecNo, addr, 1);

                //Adaptive Filter  initialization
                printf("\n\r Adaptive Filter  Coefficients\n\r");
                addr=0x91;
                read2codecArrayPrintf(codecNo, addr, 4);

                //Loop supervison initialization
                printf(" \n\rLoop Supervision Coefficients\n\r");
                addr=0xc3;
                read2codecArrayPrintf(codecNo, addr, 11);

                //Analog gain settings
                printf("\n\r Analog Gain Settings  Coefficients\n\r");
                addr=0xcb;
                read2codecArrayPrintf(codecNo, addr, 1);

                //configure adpative filter
                addr=0x61;
                printf("\n\rAdaptive Filter \n\r");
                read2codecArrayPrintf(codecNo, addr, 1);

                // Channel Configuration Register Tx/Rx/HPC/Rxpcm Enabled
                addr=0x63;
                printf("\n\rConfiguration channel Register: TXHPCRX\n\r");
                read2codecArrayPrintf(codecNo, addr, 1);
                // Transmit Time Slot
                addr=0x41;
                printf("\n\rTransit Time Slot\n\r");
                read2codecArrayPrintf(codecNo, addr, 1);

                //Receive Time slot register
                addr=0x43;
                printf("\n\rReceive Time Slot Register\n\r");
                read2codecArrayPrintf(codecNo, addr, 1);

                // Clock skew  // Only once
                addr=0x45;
                printf("\n\rClock Skew \n\r");
                read2codecArrayPrintf(codecNo, addr, 1);

                //Signal generator  initialization
                addr=0xd3;
                printf("\n\rSignal Generator \n\r");
                read2codecArrayPrintf(codecNo, addr, 10);

                addr=0x57;
                data = read2codec2wordprintf(codecNo, addr);

                addr=0x75;
                data = read2codec2wordprintf(codecNo, addr);

        }

}
#endif
