#ifndef _LE88Series_H_
#define _LE88Series_H_


/* Codec type */
#define CODEC_TYPES_NUMBER 			0x4 /* Le88221/88241/Le88111/Le88131 */
/* Legerity registers definitions */
#define CODEC_REG_HW_RESET 			0x04
#define CODEC_REG_TX_TS_W			0x40
#define CODEC_REG_TX_TS_R			0x41
#define CODEC_REG_RX_TS_W			0x42
#define CODEC_REG_RX_TS_R			0x43
#define CODEC_REG_TS_EDGE_W                     0x44
#define CODEC_REG_TS_EDGE_R                     0x45
#define CODEC_REG_CFG_W    			0x46
#define CODEC_REG_CFG_R				0x47
#define CODEC_REG_CH_CHAN_ENABLE_W	        0x4A
#define CODEC_REG_CH_CHAN_ENABLE_R              0x4B
#define CODEC_REG_READ_SIGNAL_POLL 	        0x4D
#define CODEC_REG_READ_SIGANL_INTR	        0x4F
#define CODEC_REG_VOICE_GAIN_W                  0x50
#define CODEC_REG_VOICE_GAIN_R                  0x51
#define CODEC_REG_IO_DATA_W			0x52
#define CODEC_REG_IO_DATA_R			0x53
#define CODEC_REG_IO_DIRECTION_W	        0x54
#define CODEC_REG_IO_DIRECTION_R                0x55
#define CODEC_REG_SYS_STATE_W	 	        0x56
#define CODEC_REG_SYS_STATE_R		        0x57
#define CODEC_REG_OPR_FUN_W			0x60
#define CODEC_REG_OPR_FUN_R			0x61
#define CODEC_REG_SYS_STATECFG_W                0x68
#define CODEC_REG_SYS_STATECFG_R	        0x69
#define CODEC_REG_OPR_CONDITION_W	        0x70
#define CODEC_REG_OPR_CONDITION_R	        0x71
#define CODEC_REG_PCN_R				0x73
#define CODEC_REG_GX_FLITER_W 		        0x80
#define CODEC_REG_GX_FLITER_R 		        0x81
#define CODEC_REG_GR_FLITER_W		        0x82
#define CODEC_REG_GR_FLITER_R		        0x83
#define CODEC_REG_B_FIR_FLITER_W	        0x86
#define CODEC_REG_B_FIR_FLITER_R	        0x87
#define CODEC_REG_X_FLITER_W		        0x88
#define CODEC_REG_X_FLITER_R		        0x89
#define CODEC_REG_R_FLITER_W                    0x8A
#define CODEC_REG_R_FLITER_R                    0x8B
#define CODEC_REG_B_IIR_FLITER_W	        0x96
#define CODEC_REG_B_IIR_FLITER_R	        0x97
#define CODEC_REG_Z_FIR_FILITER_W	        0x98
#define CODEC_REG_Z_FIR_FILITER_R	        0x99
#define CODEC_REG_Z_IIR_FLITER_W                0x9A
#define CODEC_REG_Z_IIR_FLITER_R                0x9B
#define CODEC_REG_LOOP_SUPERVISION_W            0xC2
#define CODEC_REG_LOOP_SUPERVISION_R            0xC3
#define CODEC_REG_DC_FEED_W   		        0xC6
#define CODEC_REG_DC_FEED_R   		        0xC7
#define CODEC_REG_DISN_W			0xCA
#define CODEC_REG_DISN_R			0xCB
#define CODEC_REG_SIG_GEN_PARA_W	        0xD2
#define CODEC_REG_SIG_GEN_PARA_R  	        0xD3
#define CODEC_REG_SIG_GEN_CTL_W		        0xDE
#define CODEC_REG_SIG_GEN_CTL_R		        0xDF
#define CODEC_REG_CANDECE_TIMER_W	        0xE0
#define CODEC_REG_CANDECE_TIMER_R               0xE1
#define CODEC_REG_REGULATOR_PARA_W	        0xE4
#define CODEC_REG_REGULATOR_PARA_R	        0xE5
#define CODEC_REG_SRC_W				0xE6
#define CODEC_REG_SRC_R				0xE7

/* Codec state */

#define CODEC_STATE_DISCONNECT		        0x00
#define CODEC_STATE_IDLE			0x24
#define CODEC_STATE_BALANCE_RINGING	        0x27
#define CODEC_STATE_ACTIVE			0x23

/* Impedance Type */
#define CODEC_IPD_CPLX 				0		/* China complex */
#define CODEC_IPD_600OHM 			1		/* 600 ohm */
#define CODEC_IPD_900OHM 			2		/* 900 ohm */

#define CODEC_MAX_IMPEDANCE_TYPE 	        3  

/* Tone type */
#define CODEC_MAX_TONE_TYPE         	        1
#define CODEC_RINGING_TONE			0



#if 0
extern unsigned char gaucLegerity_ID[CODEC_TYPES_NUMBER][2];
extern unsigned char Impedance_VOICE_GAIN[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][1];
extern unsigned char Impedance_OPCOND[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][1];
extern unsigned char Impedance_TX_GAIN[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][2];
extern unsigned char Impedance_RX_GAIN[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][2];
extern unsigned char Impedance_B_FIR_COFF[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][14];
extern unsigned char Impedance_X_COFF[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][12];
extern unsigned char Impedance_R_COFF[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][14];
extern unsigned char Impedance_B_IIR_COFF[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][2];
extern unsigned char Impedance_Z_FIR_COFF[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][10];
extern unsigned char Impedance_Z_IIR_COFF[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][5];
extern unsigned char Impedance_DIMDENCE[CODEC_TYPES_NUMBER * CODEC_MAX_IMPEDANCE_TYPE][1];
extern unsigned char TONE_SIGNAL_GEN[CODEC_TYPES_NUMBER * CODEC_MAX_TONE_TYPE][11];
extern unsigned char TONE_CADENCE[CODEC_TYPES_NUMBER * CODEC_MAX_TONE_TYPE][4];
extern unsigned char REGULATOR_PARA[3];
extern unsigned char LOOP_SUPERVISION[CODEC_TYPES_NUMBER][4];
extern unsigned char DC_FEED[CODEC_TYPES_NUMBER][2];


#endif

#endif

