#ifndef __SLIC_PROC_H__
#define __SLIC_PROC_H__

extern struct proc_dir_entry * proc_bus_spi_slic;
extern struct proc_dir_entry * proc_bus_spi;

// FXO 
extern int slic_si3050_proc_init(void);
extern void slic_si3050_proc_cleanup(void);

// FXS 
extern int slic_si3216_proc_init(void);
extern void slic_si3216_proc_cleanup (void);

// TONE test 
extern int tone_proc_init(void);
extern void slic_tone_proc_cleanup (void);

// spi bus itself ... 
extern int spi_bus_proc_init (void); // todo
extern void spi_bus_proc_cleanup (void); // todo 

// Main slic driver
extern int slic_init_procfs(void);
extern void slic_remove_procfs(void);


// Used to decode write commands 
extern int slic_proc_decode_cmd(char * cmd, int count,  int * reg, unsigned int * value, int * indirect);

// Comannds returned by slic_proc_decode_cmd :

#define SLIC_PROC_WRITE_REG	0
#define SLIC_PROC_READ_REG	1
#define SLIC_PROC_RESET_SPI	2
#define SLIC_PROC_TRACE		3
#define SLIC_PROC_SHOW_SPI_CONF 4
#define SLIC_PROC_SETBAUD	5
#define SLIC_PROC_SET_CS_RAISE	6
#define SLIC_PROC_SET_SPI_CTL	7
#define SLIC_PROC_SET_AUTORESET 8
#define SLIC_PROC_USE_HACK	9
#define SLIC_PROC_LINE_MONITORING	10


#endif //__SLIC_PROC_H__ 
